## connectome-workbench 2.1.0

=== src/CMakeLists.txt ===
#
# Minimum required version of CMAKE
#
CMAKE_MINIMUM_REQUIRED (VERSION 3.5...4.0)

#
# Project name
#
PROJECT(Workbench)

SET(WB_VERSION "2.1.0")
#
# Set to true for verbose output when debugging this file
#
SET(WB_CMAKE_VERBOSE_OUTPUT_FLAG TRUE)

#
# if this include is not present you will get
# Unknown CMake command "CHECK_CXX_COMPILER_FLAG"
#
include(CheckCXXCompilerFlag)

##########################################################################################
#
# A function to get all user defined variables with a specified prefix
# From https://cmake.org/Wiki/CMake/Tutorials/SettingVariableGroups
#
function (getListOfVarsStartingWith _prefix _varResult)
    get_cmake_property(_vars CACHE_VARIABLES)
    string (REGEX MATCHALL "(^|;)${_prefix}[A-Za-z0-9_]*" _matchedVars "${_vars}")
    set (${_varResult} ${_matchedVars} PARENT_SCOPE)
endfunction()


##########################################################################################
#
# Workbench CACHE variables
# TSC: use "CACHE <type> <docstring>" syntax in SET commands so they can be overridden by cmake options
#
set (WORKBENCH_QT5_DISABLE_DEPRECATED FALSE CACHE BOOL 
     "If TRUE, use of Qt 5 deprecated functionality will cause compiler to fail")
set (WORKBENCH_USE_CMAKE_AUTOMOC FALSE CACHE BOOL 
     "If TRUE, use CMAKE_AUTOMOC command for generating 'moc' files")
set (WORKBENCH_INCLUDE_HELP_HTML_RESOURCES TRUE CACHE BOOL
     "If TRUE, help (html) pages in src/Resources/Help are available in wb_view")
set (WORKBENCH_USE_QT6 FALSE CACHE BOOL
     "If TRUE, require Qt6.<NEWLINE>Specify as argument to cmake: -DWORKBENCH_USE_QT6=TRUE")
set (WORKBENCH_USE_QT5 TRUE CACHE BOOL
     "If TRUE, require Qt5.<NEWLINE>Specify as argument to cmake: -DWORKBENCH_USE_QT5=TRUE")
set (WORKBENCH_USE_QT5_QOPENGL_WIDGET FALSE CACHE BOOL 
     "With Qt5, QOpenGLWidget instead of deprecated QGLWidget")
set (WORKBENCH_MESA_DIR "" CACHE PATH 
     "Directory containing Mesa's 'include' and 'lib' <NEWLINE>directories.  Mesa is optional and used by <NEWLINE>wb_command's -show-scene operation.")
set (WORKBENCH_APPLE_WB_COMMAND_BUNDLE_FLAG TRUE CACHE BOOL
     "On Apple Only: 
           If TRUE, build wb_command as a MacOS Bundle (wb_command.app).
           If FALSE, build wb_command as a normal UNIX executable."
)

#
# Use when FindOpenMP does not work such as on Macs
#
set (WORKBENCH_OPENMP_COMPILER_FLAGS "" CACHE STRING
    "OpenMP compiler flags for when FindOpenMP does not work")
set (WORKBENCH_OPENMP_INCLUDE_DIR    "" CACHE STRING
    "OpenMP include directory for when FindOpenMP does not work")
set (WORKBENCH_OPENMP_LIBRARY        "" CACHE STRING
    "OpenMP library path (path and lib) for when FindOpenMP does not work")

#
# OME ZARR LIB
#
set (WORKBENCH_USE_Z5 FALSE CACHE BOOL
     "If TRUE, compile with support for Z5 and related packages for reading OME-ZARR files")
set (WORKBENCH_Z5_PATH "" CACHE PATH
     "Optional path for finding Z5 and related packages (gets appended to CMAKE_PREFIX_PATH)")

##########################################################################################
#
# Setting the compiler MUST be done before the PROJECT
# statement or else an infinite loop will occur indicating
# that the compiler has been redefined.
#
IF(APPLE)
    ADD_DEFINITIONS(-DCARET_OS_MACOSX)
ELSEIF(UNIX)
    IF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        ADD_DEFINITIONS(-DCARET_OS_LINUX)
        SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
    ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
ELSEIF(WIN32)
    ADD_DEFINITIONS(-DCARET_OS_WINDOWS)
    # Policy CMP0020 is related to Qt
    # https://cmake.org/cmake/help/v3.5/policy/CMP0020.html
    if(POLICY CMP0020) 
        cmake_policy(SET CMP0020 NEW)
    endif()
    IF(MSVC)
        ADD_DEFINITIONS(-DCARET_OS_WINDOWS_MSVC)
            ADD_DEFINITIONS(-D_USE_MATH_DEFINES -DNOMINMAX)
            SET( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -MP -wd4290 -wd4244 -wd4267 -wd4305 -wd4100 -wd4005" )
        IF(CMAKE_CL_64)
        ELSE()
        ENDIF(CMAKE_CL_64)
    ELSE(MSVC)
    ENDIF(MSVC)
ELSE(APPLE)
    MESSAGE(SEND_ERROR "Unrecognized operating system " ${CMAKE_SYSTEM_NAME})
ENDIF(APPLE)

#
# Intel compiler
#
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter")
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*icpc$")

#
# Clang compiler on Mac
#
UNSET(CLANG_FLAG)
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang\\+\\+.*")
IF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
    SET(CLANG_FLAG TRUE)
ENDIF (${CMAKE_CXX_COMPILER} MATCHES "^.*clang2\\+\\+.*")
IF (CLANG_FLAG)
    ADD_DEFINITIONS("-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter -Wno-deprecated-declarations")

    execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE CLANG_VERSION)
    message("clang version is: " ${CLANG_VERSION})
    # clang 14.0.3 on Mac outputs many many
    # "Implicit conversion loses integer precision warnings"
    if(${CLANG_VERSION} VERSION_GREATER "14.0.2")
        ADD_DEFINITIONS(-Wno-shorten-64-to-32)
    endif()
ENDIF (CLANG_FLAG)


#
# IF GNU compiler, functions without a return type or switch
# statements that do not handle all of the enumerated types
# are treated as an error.  Also, all warnings.
#
IF (NOT MSVC)
    if (CMAKE_COMPILER_IS_GNUCC)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                        OUTPUT_VARIABLE GCC_VERSION)
        message("gcc version is: " ${GCC_VERSION})
        if(${GCC_VERSION} VERSION_LESS "4.2")
            ADD_DEFINITIONS(-W -Wall)
        else()
            ADD_DEFINITIONS(-W -Wall -Werror=return-type -Werror=switch -Wunused-parameter)
        endif()

        if (${GCC_VERSION} VERSION_LESS "4.9")
            # there is no greater than or equal in CMake
        else()
            ADD_DEFINITIONS(-Wno-narrowing -Wno-unused-local-typedefs)
        endif()
    endif()

    CHECK_CXX_COMPILER_FLAG(-Wno-deprecated-copy HAVE_NO_COPY_DEPRECATED_FLAG)
    IF (${HAVE_NO_COPY_DEPRECATED_FLAG})
        # Disable warning "definition of implicit copy constructor is deprecated"
        # that occurs in many parts of Qt with newer compilers
        ADD_DEFINITIONS("-Wno-deprecated-copy")
    ENDIF()
ENDIF (NOT MSVC)

##########################################################################################
#
# If GNU compiler, use SIMD-based dot computation, if possible
#
SET(SIMD_RESULT "Search for SIMD disabled for compiler on this system.")
if ((CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG) AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    #
    # Define flag to avoid trying to compile SIMD stuff (coded for x86_64 only)
    #
    SET(WORKBENCH_USE_SIMD TRUE CACHE BOOL "try to compile with SIMD support")

    #
    # If we should try to use SIMD, check whether cpuinfo compiles
    #
    IF (WORKBENCH_USE_SIMD)
        TRY_COMPILE(CPUINFO_COMPILES ${CMAKE_CURRENT_BINARY_DIR}/cpuinfo_compile_test ${CMAKE_CURRENT_SOURCE_DIR}/kloewe/cpuinfo cpuinfo)
        
        #
        # Add the necessary definition and include directory to enable the 
        # SIMD-based dot product implementations
        #
        IF (CPUINFO_COMPILES)
            ADD_DEFINITIONS(-DCARET_DOTFCN)
            INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/kloewe/dot/src)
            SET(SIMD_RESULT "Enabled")
        ELSE()
            SET(SIMD_RESULT "Failed when compiling with SIMD")
        ENDIF()
    ELSE (WORKBENCH_USE_SIMD)
        SET(SIMD_RESULT "Search for SIMD disabled, WORKBENCH_USE_SIMD=FALSE")
    ENDIF (WORKBENCH_USE_SIMD)
endif ((CMAKE_COMPILER_IS_GNUCC OR CLANG_FLAG) AND CMAKE_SIZEOF_VOID_P EQUAL 8)

#TSC: we require c++11, so it needs to be in the compile flags - in older cmake, this needs to be done manually
IF (${CMAKE_VERSION} VERSION_LESS "3.1")
    IF (CMAKE_COMPILER_IS_GNUCC)
        include(CheckCXXCompilerFlag)
        CHECK_CXX_COMPILER_FLAG("-std=c++11" GCC_STD11)
        IF (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
        ELSE (${GCC_STD11})
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
        ENDIF (${GCC_STD11})
    ENDIF (CMAKE_COMPILER_IS_GNUCC)
ELSE (${CMAKE_VERSION} VERSION_LESS "3.1")
    SET(CMAKE_CXX_STANDARD 11)
    SET(CMAKE_CXX_STANDARD_REQUIRED TRUE)
ENDIF (${CMAKE_VERSION} VERSION_LESS "3.1")

##########################################################################################
#
# OpenSSL
#
SET(OPENSSL_RESULT "Not Found")
FIND_PACKAGE(OpenSSL)
IF(OPENSSL_FOUND)
    INCLUDE_DIRECTORIES(${OPENSSL_INCLUDE_DIR})
    SET(OPENSSL_RESULT "${OPENSSL_VERSION}   ${OPENSSL_LIBRARIES}")
ELSE (OPENSSL_FOUND)
    MESSAGE("OpenSSL NOT FOUND.  May need to define OPENSSL_ROOT_DIR when running CMake.")
    MESSAGE("   cmake -DOPENSSL_ROOT_DIR=<path> \n")
    MESSAGE("See: https://cmake.org/cmake/help/v3.5/module/FindOpenSSL.html")
ENDIF(OPENSSL_FOUND)

##########################################################################################
#
# Must have QT 6 or QT 5, recommended 5.6 or later
# https://cmake.org/cmake/help/v3.5/manual/cmake-packages.7.html#manual:cmake-packages(7)
# Modules List: http://doc.qt.io/qt-5/qtmodules.html
#
SET(WB_WEBKIT_COMPONENTS "")
SET(WB_WEBKIT_LIBS "")
SET(HAVE_QT_WEBKIT False)
SET(QT_RESULT "Not Found")

SET(CARET_QT5_LINK "")

IF (WORKBENCH_USE_QT6)
    IF (WORKBENCH_USE_QT5)
        MESSAGE(SEND_ERROR "Both QT5 and QT6 are selected.  Choose only one of them.")
    ENDIF (WORKBENCH_USE_QT5)
    
    #
    # Qt 6 requires C++17 compiler
    #
    SET(CMAKE_CXX_STANDARD 17)
    SET(CMAKE_CXX_STANDARD_REQUIRED ON)
    
    #
    # Packages for Qt 6
    #
    FIND_PACKAGE(Qt6 REQUIRED COMPONENTS Concurrent Core Core5Compat Gui Network OpenGLWidgets PrintSupport Test Widgets Xml)
    
    #
    # Always use OpenGL Widget (GLWidget not available)
    #
    add_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)

    SET(QT_RESULT "${Qt6_VERSION}")
    
ELSEIF (WORKBENCH_USE_QT5)
    #
    # The OpenGL module is deprecated in Qt5 and 
    # is needed only if QGLWidget is used for
    # the OpenGL graphics.
    #
    IF (NOT WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        SET(WB_QT_OPENGL_MODULE "OpenGL")
    ENDIF ()

    FIND_PACKAGE(Qt5 REQUIRED COMPONENTS Concurrent Core Gui Network ${WB_QT_OPENGL_MODULE} PrintSupport Test Widgets Xml ${WB_WEBKIT_COMPONENTS})
    IF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        #
        # QGLWidget is deprecated in Qt 5 and is replaced with QOpenGLWidget
        #
        # If WORKBENCH_USE_QT5_QOPENGL_WIDGET is defined, QOpenGLWidget is used
        # for OpenGL.  Otherwise, QGLWidget is used.
        #
        add_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ELSE (WORKBENCH_USE_QT5_QOPENGL_WIDGET)
        remove_definitions(-DWORKBENCH_USE_QT5_QOPENGL_WIDGET)
    ENDIF (WORKBENCH_USE_QT5_QOPENGL_WIDGET)

    IF (WORKBENCH_QT5_DISABLE_DEPRECATED)
        # Causes Qt to remove declarations for deprecated functionality
        add_definitions(-DQT_DISABLE_DEPRECATED_BEFORE=0x060000) 
    ENDIF (WORKBENCH_QT5_DISABLE_DEPRECATED)

    #small hack to get the qt5 compile flag requirements into libraries
    SET(CARET_QT5_LINK "Qt5::Core")

    SET(QT_RESULT "${Qt5_VERSION}")
    
    IF (HAVE_QT_WEBKIT)
        ADD_DEFINITIONS(-DHAVE_WEBKIT)
        SET (WB_WEBKIT_COMPONENTS "WebEngine WebEngineCore WebEngineWidgets")
        SET (WB_WEBKIT_LIBS "Qt5::WebEngine Qt5::WebEngineCore Qt5::WebEngineWidgets")

    ENDIF (HAVE_QT_WEBKIT)
ELSE ()
    MESSAGE(SEND_ERROR "QT5 or QT6 REQUIRED")
ENDIF ()

##########################################################################################
#
# Try to find Qwt, otherwise use bundle
#
SET(QWT_RESULT "Not Found")
IF (NOT WIN32)
    PKG_CHECK_MODULES(Qwt qwt)
ENDIF (NOT WIN32)
IF (Qwt_FOUND)
    SET(QWT_RESULT "Using Qwt Library ${Qwt_LIBRARIES}")
ELSE (Qwt_FOUND)

=== src/Algorithms/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Algorithms)

#
# Need XML from Qt
#
SET(QT_DONT_USE_QTGUI)

#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()

#
# Create the helper library
#
ADD_LIBRARY(Algorithms
AbstractAlgorithm.h
AlgorithmAnnotationResample.h
AlgorithmBorderResample.h
AlgorithmBorderToVertices.h
AlgorithmCiftiAllLabelsToROIs.h
AlgorithmCiftiAverageDenseROI.h
AlgorithmCiftiAverageROICorrelation.h
AlgorithmCiftiCorrelation.h
AlgorithmCiftiCorrelationGradient.h
AlgorithmCiftiCreateDenseScalar.h
AlgorithmCiftiCreateDenseTimeseries.h
AlgorithmCiftiCreateLabel.h
AlgorithmCiftiCrossCorrelation.h
AlgorithmCiftiDilate.h
AlgorithmCiftiErode.h
AlgorithmCiftiExtrema.h
AlgorithmCiftiFalseCorrelation.h
AlgorithmCiftiFindClusters.h
AlgorithmCiftiGradient.h
AlgorithmCiftiLabelAdjacency.h
AlgorithmCiftiLabelModifyKeys.h
AlgorithmCiftiLabelProbability.h
AlgorithmCiftiLabelToBorder.h
AlgorithmCiftiLabelToROI.h
AlgorithmCiftiMergeDense.h
AlgorithmCiftiMergeParcels.h
AlgorithmCiftiPairwiseCorrelation.h
AlgorithmCiftiParcellate.h
AlgorithmCiftiParcelMappingToLabel.h
AlgorithmCiftiReduce.h
AlgorithmCiftiReorder.h
AlgorithmCiftiReplaceStructure.h
AlgorithmCiftiResample.h
AlgorithmCiftiRestrictDenseMap.h
AlgorithmCiftiROIsFromExtrema.h
AlgorithmCiftiSeparate.h
AlgorithmCiftiSmoothing.h
AlgorithmCiftiTranspose.h
AlgorithmCiftiVectorOperation.h
AlgorithmCreateSignedDistanceVolume.h
AlgorithmException.h
AlgorithmFiberDotProducts.h
AlgorithmFociResample.h
AlgorithmGiftiAllLabelsToROIs.h
AlgorithmGiftiLabelAddPrefix.h
AlgorithmGiftiLabelToROI.h
AlgorithmLabelDilate.h
AlgorithmLabelErode.h
AlgorithmLabelModifyKeys.h
AlgorithmLabelProbability.h
AlgorithmLabelResample.h
AlgorithmLabelToBorder.h
AlgorithmLabelToVolumeMapping.h
AlgorithmMetricDilate.h
AlgorithmMetricErode.h
AlgorithmMetricEstimateFWHM.h
AlgorithmMetricExtrema.h
AlgorithmMetricFalseCorrelation.h
AlgorithmMetricFillHoles.h
AlgorithmMetricFindClusters.h
AlgorithmMetricGradient.h
AlgorithmMetricReduce.h
AlgorithmMetricRegression.h
AlgorithmMetricRemoveIslands.h
AlgorithmMetricResample.h
AlgorithmMetricROIsFromExtrema.h
AlgorithmMetricROIsToBorder.h
AlgorithmMetricSmoothing.h
AlgorithmMetricTFCE.h
AlgorithmMetricToVolumeMapping.h
AlgorithmMetricVectorOperation.h
AlgorithmMetricVectorTowardROI.h
AlgorithmNodesInsideBorder.h
AlgorithmSignedDistanceToSurface.h
AlgorithmSurfaceAffineRegression.h
AlgorithmSurfaceApplyAffine.h
AlgorithmSurfaceApplyWarpfield.h
AlgorithmSurfaceAverage.h
AlgorithmSurfaceCortexLayer.h
AlgorithmSurfaceCreateSphere.h
AlgorithmSurfaceCurvature.h
AlgorithmSurfaceDistortion.h
AlgorithmSurfaceFlipLR.h
AlgorithmSurfaceGenerateInflated.h
AlgorithmSurfaceInflation.h
AlgorithmSurfaceMatch.h
AlgorithmSurfaceModifySphere.h
AlgorithmSurfaceResample.h
AlgorithmSurfaceSmoothing.h
AlgorithmSurfaceSphereProjectUnproject.h
AlgorithmSurfaceToSurface3dDistance.h
AlgorithmSurfaceWedgeVolume.h
AlgorithmVolumeAffineResample.h
AlgorithmVolumeAllLabelsToROIs.h
AlgorithmVolumeDilate.h
AlgorithmVolumeDistortion.h
AlgorithmVolumeErode.h
AlgorithmVolumeEstimateFWHM.h
AlgorithmVolumeExtrema.h
AlgorithmVolumeFillHoles.h
AlgorithmVolumeFindClusters.h
AlgorithmVolumeGradient.h
AlgorithmVolumeLabelModifyKeys.h
AlgorithmVolumeLabelProbability.h
AlgorithmVolumeLabelToROI.h
AlgorithmVolumeLabelToSurfaceMapping.h
AlgorithmVolumeParcelResampling.h
AlgorithmVolumeParcelResamplingGeneric.h
AlgorithmVolumeParcelSmoothing.h
AlgorithmVolumeReduce.h
AlgorithmVolumeRemoveIslands.h
AlgorithmVolumeResample.h
AlgorithmVolumeROIsFromExtrema.h
AlgorithmVolumeSmoothing.h
AlgorithmVolumeTFCE.h
AlgorithmVolumeToSurfaceMapping.h
AlgorithmVolumeVectorOperation.h
AlgorithmVolumeWarpfieldAffineRegression.h
AlgorithmVolumeWarpfieldResample.h
OverlapLogicEnum.h

AbstractAlgorithm.cxx
AlgorithmAnnotationResample.cxx
AlgorithmBorderResample.cxx
AlgorithmBorderToVertices.cxx
AlgorithmCiftiAllLabelsToROIs.cxx
AlgorithmCiftiAverageDenseROI.cxx
AlgorithmCiftiAverageROICorrelation.cxx
AlgorithmCiftiCorrelation.cxx
AlgorithmCiftiCorrelationGradient.cxx
AlgorithmCiftiCreateDenseScalar.cxx
AlgorithmCiftiCreateDenseTimeseries.cxx
AlgorithmCiftiCreateLabel.cxx
AlgorithmCiftiCrossCorrelation.cxx
AlgorithmCiftiDilate.cxx
AlgorithmCiftiErode.cxx
AlgorithmCiftiExtrema.cxx
AlgorithmCiftiFalseCorrelation.cxx
AlgorithmCiftiFindClusters.cxx
AlgorithmCiftiGradient.cxx
AlgorithmCiftiLabelAdjacency.cxx
AlgorithmCiftiLabelModifyKeys.cxx
AlgorithmCiftiLabelProbability.cxx
AlgorithmCiftiLabelToBorder.cxx
AlgorithmCiftiLabelToROI.cxx
AlgorithmCiftiMergeDense.cxx
AlgorithmCiftiMergeParcels.cxx
AlgorithmCiftiPairwiseCorrelation.cxx
AlgorithmCiftiParcellate.cxx
AlgorithmCiftiParcelMappingToLabel.cxx
AlgorithmCiftiReduce.cxx
AlgorithmCiftiReorder.cxx
AlgorithmCiftiReplaceStructure.cxx
AlgorithmCiftiResample.cxx
AlgorithmCiftiRestrictDenseMap.cxx
AlgorithmCiftiROIsFromExtrema.cxx
AlgorithmCiftiSeparate.cxx
AlgorithmCiftiSmoothing.cxx
AlgorithmCiftiTranspose.cxx
AlgorithmCiftiVectorOperation.cxx
AlgorithmCreateSignedDistanceVolume.cxx
AlgorithmException.cxx
AlgorithmFiberDotProducts.cxx
AlgorithmFociResample.cxx
AlgorithmGiftiAllLabelsToROIs.cxx
AlgorithmGiftiLabelAddPrefix.cxx
AlgorithmGiftiLabelToROI.cxx
AlgorithmLabelDilate.cxx
AlgorithmLabelErode.cxx
AlgorithmLabelModifyKeys.cxx
AlgorithmLabelProbability.cxx
AlgorithmLabelResample.cxx
AlgorithmLabelToBorder.cxx
AlgorithmLabelToVolumeMapping.cxx
AlgorithmMetricDilate.cxx
AlgorithmMetricErode.cxx
AlgorithmMetricEstimateFWHM.cxx
AlgorithmMetricExtrema.cxx
AlgorithmMetricFalseCorrelation.cxx
AlgorithmMetricFillHoles.cxx
AlgorithmMetricFindClusters.cxx
AlgorithmMetricGradient.cxx
AlgorithmMetricReduce.cxx
AlgorithmMetricRegression.cxx
AlgorithmMetricRemoveIslands.cxx
AlgorithmMetricResample.cxx
AlgorithmMetricROIsFromExtrema.cxx
AlgorithmMetricROIsToBorder.cxx
AlgorithmMetricSmoothing.cxx
AlgorithmMetricTFCE.cxx
AlgorithmMetricToVolumeMapping.cxx
AlgorithmMetricVectorOperation.cxx
AlgorithmMetricVectorTowardROI.cxx
AlgorithmNodesInsideBorder.cxx
AlgorithmSignedDistanceToSurface.cxx
AlgorithmSurfaceAffineRegression.cxx
AlgorithmSurfaceApplyAffine.cxx
AlgorithmSurfaceApplyWarpfield.cxx
AlgorithmSurfaceAverage.cxx
AlgorithmSurfaceCortexLayer.cxx
AlgorithmSurfaceCreateSphere.cxx
AlgorithmSurfaceCurvature.cxx
AlgorithmSurfaceDistortion.cxx
AlgorithmSurfaceFlipLR.cxx
AlgorithmSurfaceGenerateInflated.cxx
AlgorithmSurfaceInflation.cxx
AlgorithmSurfaceMatch.cxx
AlgorithmSurfaceModifySphere.cxx
AlgorithmSurfaceResample.cxx
AlgorithmSurfaceSmoothing.cxx
AlgorithmSurfaceSphereProjectUnproject.cxx
AlgorithmSurfaceToSurface3dDistance.cxx
AlgorithmSurfaceWedgeVolume.cxx
AlgorithmVolumeAffineResample.cxx
AlgorithmVolumeAllLabelsToROIs.cxx
AlgorithmVolumeDilate.cxx
AlgorithmVolumeDistortion.cxx
AlgorithmVolumeErode.cxx
AlgorithmVolumeEstimateFWHM.cxx
AlgorithmVolumeExtrema.cxx
AlgorithmVolumeFillHoles.cxx
AlgorithmVolumeFindClusters.cxx
AlgorithmVolumeGradient.cxx
AlgorithmVolumeLabelModifyKeys.cxx
AlgorithmVolumeLabelProbability.cxx
AlgorithmVolumeLabelToROI.cxx
AlgorithmVolumeLabelToSurfaceMapping.cxx
AlgorithmVolumeParcelResampling.cxx
AlgorithmVolumeParcelResamplingGeneric.cxx
AlgorithmVolumeParcelSmoothing.cxx
AlgorithmVolumeReduce.cxx
AlgorithmVolumeRemoveIslands.cxx
AlgorithmVolumeResample.cxx
AlgorithmVolumeROIsFromExtrema.cxx
AlgorithmVolumeSmoothing.cxx
AlgorithmVolumeTFCE.cxx
AlgorithmVolumeToSurfaceMapping.cxx
AlgorithmVolumeVectorOperation.cxx
AlgorithmVolumeWarpfieldAffineRegression.cxx
AlgorithmVolumeWarpfieldResample.cxx
OverlapLogicEnum.cxx
)

TARGET_LINK_LIBRARIES(Algorithms ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Common
)

=== src/Annotations/CMakeLists.txt ===
#
# Name of Project
#
PROJECT (Annotations)

#
# Use XML from Qt but not GUI.
#
SET(QT_DONT_USE_QTGUI TRUE)

#
# QT include files
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    #include_directories(${Qt6Network_INCLUDE_DIRS})
    include_directories(${Qt6Xml_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    #include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
endif()

###INCLUDE(${QT_USE_FILE})

#
# Create a Library
#
ADD_LIBRARY(Annotations
Annotation.h
AnnotationAlignmentEnum.h
AnnotationAndFile.h
AnnotationAttributesDefaultTypeEnum.h
AnnotationBox.h
AnnotationBrowserTab.h
AnnotationColorBar.h
AnnotationColorBarNumericText.h
AnnotationColorBarPositionModeEnum.h
AnnotationColorBarSection.h
AnnotationCoordinate.h
AnnotationCoordinateSpaceEnum.h
AnnotationDistributeEnum.h
AnnotationEditingSelectionInformation.h
AnnotationFontAttributes.h
AnnotationFontAttributesInterface.h
AnnotationGroup.h
AnnotationGroupKey.h
AnnotationGroupTypeEnum.h
AnnotationGroupingModeEnum.h
AnnotationImage.h
AnnotationLine.h
AnnotationMultiCoordinateShape.h
AnnotationMultiPairedCoordinateShape.h
AnnotationOneCoordinateShape.h
AnnotationOval.h
AnnotationPercentSizeText.h
AnnotationPointSizeText.h
AnnotationPolygon.h
AnnotationPolyhedron.h
AnnotationPolyhedronTypeEnum.h
AnnotationPolyLine.h
AnnotationRedoUndoCommand.h
AnnotationRedoUndoCommandModeEnum.h
AnnotationSampleMetaData.h
AnnotationScaleBar.h
AnnotationScaleBarTextLocationEnum.h
AnnotationScaleBarUnitsTypeEnum.h
AnnotationSizingHandleTypeEnum.h
AnnotationSpatialModification.h
AnnotationStackingOrderOperation.h
AnnotationStackingOrderTypeEnum.h
AnnotationSurfaceOffsetVectorTypeEnum.h
AnnotationText.h
AnnotationTextAlignHorizontalEnum.h
AnnotationTextAlignVerticalEnum.h
AnnotationTextConnectTypeEnum.h
AnnotationTextFontNameEnum.h
AnnotationTextFontPointSizeEnum.h
AnnotationTextFontSizeTypeEnum.h
AnnotationTextOrientationEnum.h
AnnotationTextSubstitution.h
AnnotationTwoCoordinateShape.h
AnnotationTypeEnum.h
EventAnnotationAddToRemoveFromFile.h
EventAnnotationChartLabelGet.h
EventAnnotationGroupGetWithKey.h
EventAnnotationGrouping.h
EventAnnotationPolyhedronGetByLinkedIdentifier.h
EventAnnotationPolyhedronNameComponentSettings.h
EventAnnotationTextGetBounds.h
EventAnnotationTextSubstitutionGet.h
EventAnnotationTextSubstitutionGetAllGroupIDs.h
EventAnnotationTextSubstitutionInvalidate.h
EventAnnotationValidate.h
HistologySpaceKey.h

Annotation.cxx
AnnotationAlignmentEnum.cxx
AnnotationAndFile.cxx
AnnotationAttributesDefaultTypeEnum.cxx
AnnotationBox.cxx
AnnotationBrowserTab.cxx
AnnotationColorBar.cxx
AnnotationColorBarNumericText.cxx
AnnotationColorBarPositionModeEnum.cxx
AnnotationColorBarSection.cxx
AnnotationCoordinate.cxx
AnnotationCoordinateSpaceEnum.cxx
AnnotationDistributeEnum.cxx
AnnotationEditingSelectionInformation.cxx
AnnotationFontAttributes.cxx
AnnotationGroup.cxx
AnnotationGroupKey.cxx
AnnotationGroupTypeEnum.cxx
AnnotationGroupingModeEnum.cxx
AnnotationImage.cxx
AnnotationLine.cxx
AnnotationMultiCoordinateShape.cxx
AnnotationMultiPairedCoordinateShape.cxx
AnnotationOneCoordinateShape.cxx
AnnotationOval.cxx
AnnotationPercentSizeText.cxx
AnnotationPointSizeText.cxx
AnnotationPolygon.cxx
AnnotationPolyhedron.cxx
AnnotationPolyhedronTypeEnum.cxx
AnnotationPolyLine.cxx
AnnotationRedoUndoCommand.cxx
AnnotationRedoUndoCommandModeEnum.cxx
AnnotationSampleMetaData.cxx
AnnotationScaleBar.cxx
AnnotationScaleBarTextLocationEnum.cxx
AnnotationScaleBarUnitsTypeEnum.cxx
AnnotationSizingHandleTypeEnum.cxx
AnnotationSpatialModification.cxx
AnnotationStackingOrderOperation.cxx
AnnotationStackingOrderTypeEnum.cxx
AnnotationSurfaceOffsetVectorTypeEnum.cxx
AnnotationText.cxx
AnnotationTextAlignHorizontalEnum.cxx
AnnotationTextAlignVerticalEnum.cxx
AnnotationTextConnectTypeEnum.cxx
AnnotationTextFontNameEnum.cxx
AnnotationTextFontPointSizeEnum.cxx
AnnotationTextFontSizeTypeEnum.cxx
AnnotationTextOrientationEnum.cxx
AnnotationTextSubstitution.cxx
AnnotationTwoCoordinateShape.cxx
AnnotationTypeEnum.cxx
EventAnnotationAddToRemoveFromFile.cxx
EventAnnotationChartLabelGet.cxx
EventAnnotationGroupGetWithKey.cxx
EventAnnotationGrouping.cxx
EventAnnotationPolyhedronGetByLinkedIdentifier.cxx
EventAnnotationPolyhedronNameComponentSettings.cxx
EventAnnotationTextGetBounds.cxx
EventAnnotationTextSubstitutionGet.cxx
EventAnnotationTextSubstitutionGetAllGroupIDs.cxx
EventAnnotationTextSubstitutionInvalidate.cxx
EventAnnotationValidate.cxx
HistologySpaceKey.cxx
)

TARGET_LINK_LIBRARIES(Annotations ${CARET_QT5_LINK})

#
# Find headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Xml
)

=== src/Brain/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Brain)

#
# Need XML from Qt
#
SET(QT_DONT_USE_QTGUI)

#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    include_directories(${Qt6Core5Compat_INCLUDE_DIRS})
    include_directories(${Qt6Network_INCLUDE_DIRS})
    include_directories(${Qt6Gui_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Gui_INCLUDE_DIRS})
endif()

#
# Create the brain library
#
ADD_LIBRARY(Brain
AnnotationArrangerExecutor.h
AnnotationArrangerInputs.h
AnnotationClipboard.h
AnnotationManager.h
AnnotationTextSubstitutionLayer.h
AnnotationTextSubstitutionLayerSet.h
BorderDrawingTypeEnum.h
Brain.h
BrainOpenGL.h
BrainOpenGLAnnotationDrawingFixedPipeline.h
BrainOpenGLChartDrawingInterface.h
BrainOpenGLChartDrawingFixedPipeline.h
BrainOpenGLChartTwoDrawingFixedPipeline.h
BrainOpenGLChartTwoDrawingInterface.h
BrainOpenGLFixedPipeline.h
BrainOpenGLFociDrawing.h
BrainOpenGLHistologySliceDrawing.h
BrainOpenGLIdentificationDrawing.h
BrainOpenGLMediaCoordinateDrawing.h
BrainOpenGLMediaDrawing.h
BrainOpenGLPrimitiveDrawing.h
BrainOpenGLShape.h
BrainOpenGLShapeCone.h
BrainOpenGLShapeCube.h
BrainOpenGLShapeCylinder.h
BrainOpenGLShapeRing.h
BrainOpenGLShapeSphere.h
BrainOpenGLTextRenderInterface.h
BrainOpenGLViewportContent.h
BrainOpenGLVolumeMprThreeDrawing.h
BrainOpenGLVolumeMprTwoDrawing.h
BrainOpenGLVolumeObliqueSliceDrawing.h
BrainOpenGLVolumeSliceDrawing.h
BrainOpenGLVolumeSurfaceClippedOutlineDrawing.h
BrainOpenGLVolumeSurfaceOutlineDrawing.h
BrainOpenGLWindowContent.h
BrainStructure.h
BrainStructureNodeAttributes.h
BrowserTabContent.h
BrowserWindowContent.h
ChartTwoOverlay.h
ChartTwoOverlayActiveModeEnum.h
ChartTwoOverlaySet.h
ChartTwoOverlaySetArray.h
ChartingDataManager.h
CiftiConnectivityMatrixDataFileManager.h
CiftiFiberTrajectoryManager.h
ClippingPlaneGroup.h
ClippingPlanePanningModeEnum.h
DataToolTipsManager.h
DisplayProperties.h
DisplayPropertiesAnnotation.h
DisplayPropertiesAnnotationTextSubstitution.h
DisplayPropertiesBorders.h
DisplayPropertiesCziImages.h
DisplayPropertiesFiberOrientation.h
DisplayPropertiesFoci.h
DisplayPropertiesImages.h
DisplayPropertiesLabels.h
DisplayPropertiesSamples.h
DisplayPropertiesSurface.h
DisplayPropertiesVolume.h
DisplayPropertyDataBoolean.h
DisplayPropertyDataEnum.h
DisplayPropertyDataFloat.h
DrawingViewportContent.h
DrawingViewportContentManager.h
DrawingViewportContentSurface.h
DrawingViewportContentTypeEnum.h
DrawingViewportContentVolumeSlice.h
DummyFontTextRenderer.h
EventAnnotationBarsGet.h
EventAnnotationGetBeingDrawnInWindow.h
EventBrainReset.h
EventBrainStructureGetAll.h
EventBrowserTabGet.h
EventBrowserTabGetAll.h
EventBrowserTabGetAllViewed.h
EventBrowserTabGetAtWindowXY.h
EventBrowserTabIndexGetWindowIndex.h
EventBrowserTabReopenAvailable.h
EventBrowserTabValidate.h
EventBrowserWindowContent.h
EventBrowserWindowGetTabs.h
EventCaretMappableDataFilesAndMapsInDisplayedOverlays.h
EventChartTwoOverlayValidate.h
EventDataFileAdd.h
EventDataFileDelete.h
EventDataFileRead.h
EventDataFileReload.h
EventDataFileReloadAll.h
EventDrawingViewportContentAdd.h
EventDrawingViewportContentClear.h
EventDrawingViewportContentGet.h
EventGetBrainOpenGLTextRenderer.h
EventIdentificationHighlightLocation.h
EventImageCapture.h
EventModelAdd.h
EventModelDelete.h
EventModelGetAll.h
EventModelGetAllDisplayed.h
EventModelSurfaceGet.h
EventNodeDataFilesGet.h
EventNodeIdentificationColorsGetFromCharts.h
EventOverlayValidate.h
EventSceneActive.h
EventSpacerTabGet.h
EventSpecFileReadDataFiles.h
EventSurfacesGet.h
EventUserInputModeGet.h
FeatureColoringTypeEnum.h
FiberOrientationSamplesLoader.h
FiberOrientationSamplesVector.h
FiberOrientationSymbolTypeEnum.h
FociDrawingProjectionTypeEnum.h
FociDrawingTypeEnum.h
FtglFontTextRenderer.h
GapsAndMargins.h
HistologyOverlay.h
HistologyOverlaySet.h
HistologyOverlaySetArray.h
HistologySliceSettings.h
IdentificationFilter.h
IdentificationFilterTabSelectionEnum.h
IdentificationFormattedTextGenerator.h
IdentificationHistoryManager.h
IdentificationHistoryRecord.h
IdentificationManager.h
IdentificationSimpleTextGenerator.h
IdentificationStringBuilder.h
IdentificationSymbolSizeTypeEnum.h
IdentificationWithColor.h
IdentifiedItemBase.h
IdentifiedItemNode.h
IdentifiedItemUniversal.h
IdentifiedItemUniversalTypeEnum.h
IdentifiedItemVoxel.h
ImageDepthPositionEnum.h
MediaOverlay.h
MediaOverlaySet.h
MediaOverlaySetArray.h
Model.h
ModelChart.h
ModelChartTwo.h
ModelHistology.h
ModelMedia.h
ModelSurface.h
ModelSurfaceMontage.h
ModelSurfaceSelector.h
ModelTypeEnum.h
ModelVolume.h
ModelWholeBrain.h
MouseEvent.h
MouseLeftDragModeEnum.h
MovieRecorder.h
MovieRecorderCaptureRegionTypeEnum.h
MovieRecorderModeEnum.h
MovieRecorderVideoFormatTypeEnum.h
MovieRecorderVideoResolutionTypeEnum.h
OffScreenSceneRendererBase.h
OffScreenSceneRendererOSMesa.h
OffScreenSceneRendererOpenGLWindow.h
Overlay.h
OverlaySet.h
OverlaySetArray.h
OverlaySetInitializer.h
ProjectionViewTypeEnum.h
SamplesDrawingModeEnum.h
SamplesDrawingSettings.h
SamplesMetaDataManager.h
SelectionItemDataTypeEnum.h
SelectionItem.h
SelectionItemAnnotation.h
SelectionItemBorderSurface.h
SelectionItemChartDataSeries.h
SelectionItemChartFrequencySeries.h
SelectionItemChartMatrix.h
SelectionItemChartTimeSeries.h
SelectionItemChartTwoHistogram.h
SelectionItemChartTwoLabel.h
SelectionItemChartTwoLineLayer.h
SelectionItemChartTwoLineLayerVerticalNearest.h
SelectionItemChartTwoLineSeries.h
SelectionItemChartTwoMatrix.h
SelectionItemCiftiConnectivityMatrixRowColumn.h
SelectionItemFocusSurface.h
SelectionItemFocus.h
SelectionItemHistologyCoordinate.h
SelectionItemImageControlPoint.h
SelectionItemMediaLogicalCoordinate.h
SelectionItemMediaPlaneCoordinate.h
SelectionItemSurfaceNode.h
SelectionItemSurfaceTriangle.h
SelectionItemUniversalIdentificationSymbol.h
SelectionItemVolumeMprCrosshair.h
SelectionItemVoxel.h
SelectionItemVoxelEditing.h
SelectionManager.h
SessionManager.h
SpacerTabContent.h
Surface.h
SurfaceDrawingTypeEnum.h
SurfaceMontageConfigurationAbstract.h
SurfaceMontageConfigurationCerebellar.h
SurfaceMontageConfigurationCerebral.h
SurfaceMontageConfigurationFlatMaps.h
SurfaceMontageConfigurationHippocampus.h
SurfaceMontageConfigurationHippocampusFlatMaps.h
SurfaceMontageConfigurationTypeEnum.h
SurfaceMontageLayoutOrientationEnum.h
SurfaceMontageViewport.h
SurfaceNodeColoring.h
SurfaceSelectionModel.h
TabContentBase.h
UserInputModeEnum.h
ViewingTransformationToFitRegion.h
ViewingTransformations.h
ViewingTransformationsCerebellum.h
ViewingTransformationsMedia.h
ViewingTransformationsUndoCommand.h
ViewingTransformationsVolume.h
VolumeMprOrientationModeEnum.h
VolumeMprSettings.h
VolumeMontageSliceOrderModeEnum.h
VolumeMprViewModeEnum.h
VolumeMprViewportSlice.h
VolumeMprVirtualSliceView.h
VolumeMontageCoordinateTextAlignmentEnum.h
VolumeSliceDrawingTypeEnum.h
VolumeSliceInterpolationEdgeEffectsMaskingEnum.h
VolumeSliceSettings.h
VolumeSurfaceOutlineColorOrTabModel.h
VolumeSurfaceOutlineDrawingModeEnum.h
VolumeSurfaceOutlineModel.h
VolumeSurfaceOutlineModelCacheKey.h
VolumeSurfaceOutlineModelCacheValue.h
VolumeSurfaceOutlineSetModel.h
WholeBrainSurfaceSettings.h
WholeBrainVoxelDrawingMode.h
WindowTabAspectRatios.h

AnnotationArrangerExecutor.cxx
AnnotationArrangerInputs.cxx
AnnotationClipboard.cxx
AnnotationManager.cxx
AnnotationTextSubstitutionLayer.cxx
AnnotationTextSubstitutionLayerSet.cxx
BorderDrawingTypeEnum.cxx
Brain.cxx
BrainOpenGL.cxx
BrainOpenGLAnnotationDrawingFixedPipeline.cxx
BrainOpenGLChartDrawingFixedPipeline.cxx
BrainOpenGLChartTwoDrawingFixedPipeline.cxx
BrainOpenGLFixedPipeline.cxx
BrainOpenGLFociDrawing.cxx
BrainOpenGLHistologySliceDrawing.cxx
BrainOpenGLIdentificationDrawing.cxx
BrainOpenGLMediaCoordinateDrawing.cxx
BrainOpenGLMediaDrawing.cxx
BrainOpenGLPrimitiveDrawing.cxx
BrainOpenGLShape.cxx
BrainOpenGLShapeCone.cxx
BrainOpenGLShapeCube.cxx
BrainOpenGLShapeCylinder.cxx
BrainOpenGLShapeRing.cxx
BrainOpenGLShapeSphere.cxx
BrainOpenGLTextRenderInterface.cxx
BrainOpenGLViewportContent.cxx
BrainOpenGLVolumeMprThreeDrawing.cxx
BrainOpenGLVolumeMprTwoDrawing.cxx
BrainOpenGLVolumeObliqueSliceDrawing.cxx
BrainOpenGLVolumeSliceDrawing.cxx
BrainOpenGLVolumeSurfaceClippedOutlineDrawing.cxx
BrainOpenGLVolumeSurfaceOutlineDrawing.cxx
BrainOpenGLWindowContent.cxx
BrainStructure.cxx
BrainStructureNodeAttributes.cxx
BrowserTabContent.cxx
BrowserWindowContent.cxx
ChartTwoOverlay.cxx
ChartTwoOverlayActiveModeEnum.cxx
ChartTwoOverlaySet.cxx
ChartTwoOverlaySetArray.cxx
ChartingDataManager.cxx
CiftiConnectivityMatrixDataFileManager.cxx
CiftiFiberTrajectoryManager.cxx
ClippingPlaneGroup.cxx
ClippingPlanePanningModeEnum.cxx
DataToolTipsManager.cxx
DisplayProperties.cxx
DisplayPropertiesAnnotation.cxx
DisplayPropertiesAnnotationTextSubstitution.cxx
DisplayPropertiesBorders.cxx
DisplayPropertiesCziImages.cxx
DisplayPropertiesFiberOrientation.cxx
DisplayPropertiesFoci.cxx
DisplayPropertiesImages.cxx
DisplayPropertiesLabels.cxx
DisplayPropertiesSamples.cxx
DisplayPropertiesSurface.cxx
DisplayPropertiesVolume.cxx
DisplayPropertyDataBoolean.cxx
DisplayPropertyDataFloat.cxx
DrawingViewportContent.cxx
DrawingViewportContentManager.cxx
DrawingViewportContentSurface.cxx
DrawingViewportContentTypeEnum.cxx
DrawingViewportContentVolumeSlice.cxx
DummyFontTextRenderer.cxx
EventAnnotationBarsGet.cxx
EventAnnotationGetBeingDrawnInWindow.cxx
EventBrainReset.cxx
EventBrainStructureGetAll.cxx
EventBrowserTabGet.cxx
EventBrowserTabGetAll.cxx
EventBrowserTabGetAllViewed.cxx
EventBrowserTabGetAtWindowXY.cxx
EventBrowserTabIndexGetWindowIndex.cxx
EventBrowserTabReopenAvailable.cxx
EventBrowserTabValidate.cxx
EventBrowserWindowContent.cxx
EventBrowserWindowGetTabs.cxx
EventCaretMappableDataFilesAndMapsInDisplayedOverlays.cxx
EventChartTwoOverlayValidate.cxx
EventDataFileAdd.cxx
EventDataFileDelete.cxx
EventDataFileRead.cxx
EventDataFileReload.cxx
EventDataFileReloadAll.cxx
EventDrawingViewportContentAdd.cxx
EventDrawingViewportContentClear.cxx
EventDrawingViewportContentGet.cxx
EventGetBrainOpenGLTextRenderer.cxx
EventIdentificationHighlightLocation.cxx
EventImageCapture.cxx
EventModelAdd.cxx
EventModelDelete.cxx
EventModelGetAll.cxx
EventModelGetAllDisplayed.cxx
EventModelSurfaceGet.cxx
EventNodeDataFilesGet.cxx
EventNodeIdentificationColorsGetFromCharts.cxx
EventOverlayValidate.cxx
EventSceneActive.cxx
EventSpacerTabGet.cxx
EventSpecFileReadDataFiles.cxx
EventSurfacesGet.cxx
EventUserInputModeGet.cxx
FeatureColoringTypeEnum.cxx
FiberOrientationSamplesLoader.cxx
FiberOrientationSymbolTypeEnum.cxx
FociDrawingProjectionTypeEnum.cxx
FociDrawingTypeEnum.cxx
FtglFontTextRenderer.cxx
GapsAndMargins.cxx
HistologyOverlay.cxx
HistologyOverlaySet.cxx
HistologyOverlaySetArray.cxx
HistologySliceSettings.cxx
IdentificationFilter.cxx
IdentificationFilterTabSelectionEnum.cxx
IdentificationFormattedTextGenerator.cxx
IdentificationHistoryManager.cxx
IdentificationHistoryRecord.cxx
IdentificationManager.cxx
IdentificationSimpleTextGenerator.cxx
IdentificationStringBuilder.cxx
IdentificationSymbolSizeTypeEnum.cxx
IdentificationWithColor.cxx
IdentifiedItemBase.cxx
IdentifiedItemNode.cxx
IdentifiedItemUniversal.cxx
IdentifiedItemUniversalTypeEnum.cxx
IdentifiedItemVoxel.cxx
ImageDepthPositionEnum.cxx
MediaOverlay.cxx
MediaOverlaySet.cxx
MediaOverlaySetArray.cxx
Model.cxx
ModelChart.cxx
ModelChartTwo.cxx
ModelHistology.cxx
ModelMedia.cxx
ModelSurface.cxx
ModelSurfaceMontage.cxx
ModelSurfaceSelector.cxx
ModelTypeEnum.cxx
ModelVolume.cxx
ModelWholeBrain.cxx
MouseEvent.cxx
MouseLeftDragModeEnum.cxx
MovieRecorder.cxx
MovieRecorderCaptureRegionTypeEnum.cxx
MovieRecorderModeEnum.cxx
MovieRecorderVideoFormatTypeEnum.cxx
MovieRecorderVideoResolutionTypeEnum.cxx
OffScreenSceneRendererBase.cxx
OffScreenSceneRendererOSMesa.cxx
OffScreenSceneRendererOpenGLWindow.cxx
Overlay.cxx
OverlaySet.cxx
OverlaySetArray.cxx
OverlaySetInitializer.cxx
ProjectionViewTypeEnum.cxx
SamplesDrawingModeEnum.cxx

=== src/CZIlib/CMakeLists.txt ===
PROJECT(CZI_Library)

IF(UNIX)
# linking with 'thread' is necessary if we use std::thread and related under Linux it seems
#   otherwise - the program simply crashes (no build-error)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread -std=c++11 -fPIC -D_FILE_OFFSET_BITS=64")
   SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__ANSI__ -fPIC -D_FILE_OFFSET_BITS=64")

   ADD_DEFINITIONS("-w")
ENDIF(UNIX)

ADD_DEFINITIONS(-DWORKBENCH_CZI_MOD)

ADD_SUBDIRECTORY(CZIJxrDecode)
ADD_SUBDIRECTORY(CZI)
ADD_SUBDIRECTORY(CZICmd)

=== src/Charting/CMakeLists.txt ===

#
# Name of Project
#
PROJECT(Charting)

#
# Qt include files
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()

#
# Create a library
#
ADD_LIBRARY(Charting
ChartAxis.h
ChartAxisCartesian.h
ChartAxisLocationEnum.h
ChartAxisTypeEnum.h
ChartAxisUnitsEnum.h
ChartData.h
ChartDataCartesian.h
ChartDataSource.h
ChartDataSourceModeEnum.h
ChartMatrixDisplayProperties.h
ChartMatrixLoadingDimensionEnum.h
ChartMatrixScaleModeEnum.h
ChartModel.h
ChartModelCartesian.h
ChartModelDataSeries.h
ChartModelFrequencySeries.h
ChartModelTimeSeries.h
ChartPoint.h
ChartScaleAutoRanging.h
ChartSelectionModeEnum.h
ChartOneDataTypeEnum.h
ChartingVersionEnum.h

ChartTwoAxisOrientationTypeEnum.h
ChartTwoAxisScaleRangeModeEnum.h
ChartTwoCartesianAxis.h
ChartTwoCartesianCustomSubdivisions.h
ChartTwoCartesianCustomSubdivisionsLabel.h
ChartTwoCartesianOrientedAxes.h
ChartTwoCartesianOrientedAxesYokingManager.h
ChartTwoCartesianSubdivisionsModeEnum.h
ChartTwoCompoundDataType.h
ChartTwoDataCartesian.h
ChartTwoDataTypeEnum.h
ChartTwoHistogramContentTypeEnum.h
ChartTwoLineLayerContentTypeEnum.h
ChartTwoLineSeriesContentTypeEnum.h
ChartTwoMatrixContentTypeEnum.h
ChartTwoMatrixDisplayProperties.h
ChartTwoMatrixLoadingDimensionEnum.h
ChartTwoMatrixTriangularViewingModeEnum.h
ChartTwoNumericSubdivisionsModeEnum.h
ChartTwoLineSeriesHistory.h
ChartTwoOverlaySetInterface.h
ChartTwoTitle.h
EventChartTwoCartesianAxisDisplayGroup.h
EventChartTwoCartesianOrientedAxesYoking.h
EventChartTwoLoadLineSeriesData.h
MapFileDataSelector.h

ChartAxis.cxx
ChartAxisCartesian.cxx
ChartAxisLocationEnum.cxx
ChartAxisTypeEnum.cxx
ChartAxisUnitsEnum.cxx
ChartData.cxx
ChartDataCartesian.cxx
ChartDataSource.cxx
ChartDataSourceModeEnum.cxx
ChartMatrixDisplayProperties.cxx
ChartMatrixLoadingDimensionEnum.cxx
ChartMatrixScaleModeEnum.cxx
ChartModel.cxx
ChartModelCartesian.cxx
ChartModelDataSeries.cxx
ChartModelFrequencySeries.cxx
ChartModelTimeSeries.cxx
ChartPoint.cxx
ChartScaleAutoRanging.cxx
ChartSelectionModeEnum.cxx
ChartOneDataTypeEnum.cxx
ChartingVersionEnum.cxx

ChartTwoAxisOrientationTypeEnum.cxx
ChartTwoAxisScaleRangeModeEnum.cxx
ChartTwoCartesianAxis.cxx
ChartTwoCartesianCustomSubdivisions.cxx
ChartTwoCartesianCustomSubdivisionsLabel.cxx
ChartTwoCartesianOrientedAxes.cxx
ChartTwoCartesianOrientedAxesYokingManager.cxx
ChartTwoCartesianSubdivisionsModeEnum.cxx
ChartTwoCompoundDataType.cxx
ChartTwoDataCartesian.cxx
ChartTwoDataTypeEnum.cxx
ChartTwoHistogramContentTypeEnum.cxx
ChartTwoLineLayerContentTypeEnum.cxx
ChartTwoLineSeriesContentTypeEnum.cxx
ChartTwoMatrixContentTypeEnum.cxx
ChartTwoMatrixDisplayProperties.cxx
ChartTwoMatrixLoadingDimensionEnum.cxx
ChartTwoMatrixTriangularViewingModeEnum.cxx
ChartTwoNumericSubdivisionsModeEnum.cxx
ChartTwoLineSeriesHistory.cxx
ChartTwoOverlaySetInterface.cxx
ChartTwoTitle.cxx
EventChartTwoCartesianAxisDisplayGroup.cxx
EventChartTwoCartesianOrientedAxesYoking.cxx
EventChartTwoLoadLineSeriesData.cxx
MapFileDataSelector.cxx
)

TARGET_LINK_LIBRARIES(Charting ${CARET_QT5_LINK})

#
# Include directories
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Common
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Scenes
)

=== src/Cifti/CMakeLists.txt ===

#
# Name of Project
#
PROJECT (Cifti)

#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    include_directories(${Qt6Core5Compat_INCLUDE_DIRS})
    include_directories(${Qt6Network_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
endif()

#
# Create GIFTI Library
#
ADD_LIBRARY(Cifti
CiftiInterface.h
CiftiXMLOld.h
CiftiXMLElements.h
CiftiXMLReader.h
CiftiXMLWriter.h

CiftiFile.h
CiftiXML.h
CiftiMappingType.h
CiftiBrainModelsMap.h
CiftiLabelsMap.h
CiftiParcelsMap.h
CiftiScalarsMap.h
CiftiSeriesMap.h
CiftiVersion.h

CiftiInterface.cxx
CiftiXMLOld.cxx
CiftiXMLElements.cxx
CiftiXMLReader.cxx
CiftiXMLWriter.cxx

CiftiFile.cxx
CiftiXML.cxx
CiftiMappingType.cxx
CiftiBrainModelsMap.cxx
CiftiLabelsMap.cxx
CiftiParcelsMap.cxx
CiftiScalarsMap.cxx
CiftiSeriesMap.cxx
CiftiVersion.cxx
)

TARGET_LINK_LIBRARIES(Cifti ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

=== src/CommandLine/CMakeLists.txt ===

#
# Name of project
#
PROJECT (CommandLine)

#cmake_policy(SET CMP0015 OLD) 


#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
#    include_directories(${Qt5Network_INCLUDE_DIRS})
endif()

#
# Name of executable
#
set (EXE_NAME wb_command)

#
# Resources
#
SET (RESOURCES_QRC_FILE 
   ../Resources/Data/data_resources.qrc
   ../Resources/General/general_resources.qrc)

IF (Qt6_FOUND)
    QT6_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ENDIF (Qt6_FOUND)
IF (Qt5_FOUND)
    QT5_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ENDIF (Qt5_FOUND)

#
# Create the executable
# Apple creates a bundle
#
IF (APPLE AND ${WORKBENCH_APPLE_WB_COMMAND_BUNDLE_FLAG})
   ADD_EXECUTABLE(${EXE_NAME}
      MACOSX_BUNDLE
      wb_command.cxx
      ${IMAGE_RCS_SRCS}
   )
ELSE ()
   ADD_EXECUTABLE(${EXE_NAME}
      wb_command.cxx
      ${IMAGE_RCS_SRCS}
   )
ENDIF ()


if(Qt6_FOUND)
    set(QT6_LINK_LIBS
        Qt6::Concurrent
        Qt6::Core
        Qt6::Core5Compat
        Qt6::Gui
        Qt6::Network
        Qt6::Test
        Qt6::Xml)
endif()
if(Qt5_FOUND)
    set(QT5_LINK_LIBS
        Qt5::Concurrent
        Qt5::Core
        Qt5::Gui
        Qt5::Network
#        Qt5::OpenGL
#        Qt5::PrintSupport
        Qt5::Test
#        Qt5::Widgets
        Qt5::Xml)
endif()

SET (MESA_OR_OPENGL_LIBRARIES "")
IF (OSMESA_FOUND)
    SET(MESA_OR_OPENGL_LIBRARIES
        ${OSMESA_OFFSCREEN_LIBRARY}
        ${OSMESA_GL_LIBRARY}
        ${OSMESA_GLU_LIBRARY})
ELSE()
    IF (OPENGL_FOUND)
        SET(MESA_OR_OPENGL_LIBRARIES ${OPENGL_LIBRARIES})
    ELSE()
        MESSAGE(SEND_ERROR "Must have either OpenGL or Mesa3D for command line")
    ENDIF()
ENDIF()

#
# Libraries that are linked
# Note: GLEW_LIBRARIES and OSMESA library variables will be empty and
# have no effect if not available
#
TARGET_LINK_LIBRARIES(${EXE_NAME}
Commands
Operations
Algorithms
OperationsBase
Brain
Files
${FTGL_LIBRARIES}
Annotations
Palette
Graphics
Gifti
Cifti
Nifti
Charting
QxtCore
FilesBase
Scenes
Xml
CZICmd
CZI
CZIJxrDecode
${OME_ZARR_LIBRARY_FOR_LINKING}
Common
${QUAZIP_LIBRARIES}
${FREETYPE_LIBRARIES}
${QT_LIBRARIES}
${QT6_LINK_LIBS}
${QT5_LINK_LIBS}
${GLEW_LIBRARIES}
${MESA_OR_OPENGL_LIBRARIES}
${Z5_COMPRESSION_LIBRARIES}
${ZLIB_LIBRARIES}
${OPENMP_LIBRARY}
${LIBS})

INCLUDE(GNUInstallDirs)

INSTALL(TARGETS ${EXE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(PROGRAMS wb_shortcuts DESTINATION ${CMAKE_INSTALL_BINDIR})
INSTALL(FILES bashcomplete_wb_command DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions RENAME wb_command)
INSTALL(FILES bashcomplete_wb_shortcuts DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/bash-completion/completions RENAME wb_shortcuts)

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/CommandLine
${CMAKE_SOURCE_DIR}/Commands
${CMAKE_SOURCE_DIR}/Operations
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
${QUAZIP_INCLUDE_DIRS}
)

ENABLE_TESTING()

ADD_TEST(command_help ${EXE_NAME} -all-commands-help)

=== src/Commands/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Commands)

#
# Need XML from Qt
#
SET(QT_DONT_USE_QTGUI)

#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
endif()


#
# Create the brain library
#
ADD_LIBRARY(Commands
CommandClassAddMember.h
CommandClassCreate.h
CommandClassCreateAlgorithm.h
CommandClassCreateBase.h
CommandClassCreateEnum.h
CommandClassCreateOperation.h
CommandC11xTesting.h
CommandException.h
CommandOperation.h
CommandOperationManager.h
CommandParser.h
CommandUnitTest.h

CommandClassAddMember.cxx
CommandClassCreate.cxx
CommandClassCreateAlgorithm.cxx
CommandClassCreateBase.cxx
CommandClassCreateEnum.cxx
CommandClassCreateOperation.cxx
CommandC11xTesting.cxx
CommandException.cxx
CommandOperation.cxx
CommandOperationManager.cxx
CommandParser.cxx
CommandUnitTest.cxx
)

TARGET_LINK_LIBRARIES(Commands ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Commands
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/Operations
${CMAKE_SOURCE_DIR}/OperationsBase
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

=== src/Common/CMakeLists.txt ===

#
# Name of Project
#
PROJECT(Common)


#
# QT include files
#
SET(QT_USE_QTXML TRUE)
SET(QT_DONT_USE_QTGUI TRUE)
SET(QT_USE_QTNETWORK TRUE)

if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    include_directories(${Qt6Core5Compat_INCLUDE_DIRS})
    include_directories(${Qt6Gui_INCLUDE_DIRS})
    include_directories(${Qt6Network_INCLUDE_DIRS})
    include_directories(${Qt6Xml_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Gui_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    include_directories(${Qt5Xml_INCLUDE_DIRS})
endif()
#message("QT VERSION: " ${QT_VERSION_MAJOR} ${QT_VERSION_MINOR} ${QT_VERSION_PATCH})

#
# With AUTOMOC, do not need to specify files
# that contain Q_OBJECT macro for Qt to process with 'moc'
# (meta-object compiler).
#
IF(WORKBENCH_USE_CMAKE_AUTOMOC)
    SET(CMAKE_AUTOMOC ON)
ELSE()
    SET(MOC_INPUT_HEADER_FILES
        CaretHttpManager.h
    )

    IF(Qt6_FOUND)
        QT6_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF()
    IF(Qt5_FOUND)
        QT5_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF()
ENDIF()

#
# Create a library
#
ADD_LIBRARY(Common
ApplicationInformation.h
ApplicationTypeEnum.h
AString.h
AStringNaturalComparison.h
BackgroundAndForegroundColors.h
Base64.h
BoundingBox.h
BrainConstants.h
ByteOrderEnum.h
ByteSwapping.h
CardinalDirectionEnum.h
CaretAssert.h
CaretAssertion.h
CaretBinaryFile.h
CaretColor.h
CaretColorEnum.h
CaretCommandLine.h
CaretCompact3DLookup.h
CaretCompactLookup.h
CaretException.h
CaretFunctionName.h
CaretHeap.h
CaretHierarchy.h
CaretHttpManager.h
CaretLogger.h
CaretMathExpression.h
CaretMutex.h
CaretObject.h
CaretObjectTracksModification.h
CaretOMP.h
CaretPointer.h
CaretPointLocator.h
CaretPreferenceDataValue.h
CaretPreferenceDataValueList.h
CaretPreferenceValueSceneOverrideModeEnum.h
CaretPreferences.h
CaretResult.h
CaretRgb.h
CaretTemporaryFile.h
CaretUndoCommand.h
CaretUndoStack.h
CaretUnitsTypeEnum.h
Cluster.h
ClusterContainer.h
ColorFunctions.h
CubicSpline.h
DataCompressZLib.h
DataFile.h
DataFileContentCopyMoveInterface.h
DataFileContentCopyMoveParameters.h
DataFileContentInformation.h
DataFileException.h
DataFileInterface.h
DataFileTypeEnum.h
DescriptiveStatistics.h
DeveloperFlagsEnum.h
DisplayGroupAndTabItemInterface.h 
DisplayGroupEnum.h
DisplayHighDpiModeEnum.h
ElapsedTimer.h
Event.h
EventAlertUser.h
EventBrowserTabClose.h
EventBrowserTabDelete.h
EventBrowserTabIndicesGetAll.h
EventBrowserTabIndicesGetAllViewed.h
EventBrowserTabNew.h
EventBrowserTabNewClone.h
EventBrowserTabReopenClosed.h
EventBrowserTabSelectInWindow.h
EventBrowserWindowPixelSizeInfoEvent.h
EventCaretPreferencesGet.h
EventGetViewportSize.h
EventListenerInterface.h
EventManager.h
EventPaletteGetByName.h
EventProgressUpdate.h
EventRecentFilesSystemAccessMode.h
EventResetView.h
EventTileTabsGridConfigurationModification.h
EventTypeEnum.h
FastStatistics.h
FileAdapter.h
FileInformation.h
FileOpenFromOpSysTypeEnum.h
FloatMatrix.h
FunctionResult.h
HemisphereEnum.h
Histogram.h
HtmlStringBuilder.h
HtmlTableBuilder.h
IdentificationDisplayModeEnum.h
ImageCaptureMethodEnum.h
InfoItem.h
JsonHelper.h
LinearEquationTransform.h
Logger.h
LogHandler.h
LogHandlerStandardError.h
LogLevelEnum.h
LogManager.h
LogRecord.h
MathFunctionEnum.h
MathFunctions.h
Matrix4x4Interface.h
MatrixFunctions.h
ModelTransform.h
MultiDimArray.h
MultiDimIterator.h
NetworkException.h
NumericFormatModeEnum.h
NumericTextFormatting.h
OctTree.h
OpenGLDrawingMethodEnum.h
PlainTextStringBuilder.h
Plane.h
ProgramParameters.h
ProgramParametersException.h
ProgressObject.h
ProgressReportingInterface.h
QtPluginsPathSetup.h
RecentFileItem.h
RecentFileItemSortingKeyEnum.h
RecentFileItemTypeEnum.h
RecentFileItemsContainer.h
RecentFileItemsContainerModeEnum.h
RecentFileItemsFilter.h
RecentFilesSystemAccessModeEnum.h
RecentSceneInfoContainer.h
ReductionEnum.h
ReductionOperation.h
SpacerTabIndex.h
SpecFileDialogViewFilesTypeEnum.h
SpeciesEnum.h
StereotaxicSpaceEnum.h
StringTableModel.h
StructureEnum.h
SystemUtilities.h
TileTabsBrowserTabGeometry.h
TileTabsLayoutBackgroundTypeEnum.h
TileTabsLayoutBaseConfiguration.h
TileTabsLayoutConfigurationTypeEnum.h
TileTabsLayoutGridConfiguration.h
TileTabsLayoutManualConfiguration.h
TileTabsGridRowColumnContentTypeEnum.h
TileTabsGridRowColumnElement.h
TileTabsGridRowColumnStretchTypeEnum.h
ToolBarWidthModeEnum.h
TracksModificationInterface.h
TriStateSelectionStatusEnum.h
UnitsConversion.h
Vector3D.h
VectorOperation.h
VolumeMontageCoordinateDisplayTypeEnum.h
VolumeSliceViewAllPlanesLayoutEnum.h
VoxelColorUpdate.h
VoxelIJK.h
WorkbenchInstallationAssistant.h
WorkbenchQtMessageHandler.h
WorkbenchSpecialVersionEnum.h
WuQMacro.h
WuQMacroCommand.h
WuQMacroCommandParameter.h
WuQMacroCommandTypeEnum.h
WuQMacroDataValueTypeEnum.h
WuQMacroFile.h
WuQMacroGroup.h
WuQMacroGroupXmlStreamBase.h
WuQMacroGroupXmlStreamReader.h
WuQMacroGroupXmlStreamWriter.h
WuQMacroModeEnum.h
WuQMacroMouseEventInfo.h
WuQMacroMouseEventTypeEnum.h
WuQMacroShortCutKeyEnum.h
WuQMacroStandardItemTypeEnum.h
WuQMacroWidgetTypeEnum.h
YokingGroupEnum.h

${MOC_SOURCE_FILES}

${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
ApplicationTypeEnum.cxx
AString.cxx
AStringNaturalComparison.cxx
BackgroundAndForegroundColors.cxx
Base64.cxx
BoundingBox.cxx
BrainConstants.cxx
ByteOrderEnum.cxx
ByteSwapping.cxx
CardinalDirectionEnum.cxx
CaretAssertion.cxx
CaretBinaryFile.cxx
CaretColor.cxx
CaretColorEnum.cxx
CaretCommandLine.cxx
CaretException.cxx
CaretHierarchy.cxx
CaretHttpManager.cxx
CaretLogger.cxx
CaretMathExpression.cxx
CaretObject.cxx
CaretObjectTracksModification.cxx
CaretPointLocator.cxx
CaretPreferenceDataValue.cxx
CaretPreferenceDataValueList.cxx
CaretPreferenceValueSceneOverrideModeEnum.cxx
CaretPreferences.cxx
CaretResult.cxx
CaretRgb.cxx
CaretTemporaryFile.cxx
CaretUndoCommand.cxx
CaretUndoStack.cxx
CaretUnitsTypeEnum.cxx
Cluster.cxx
ClusterContainer.cxx
ColorFunctions.cxx
CubicSpline.cxx
DataCompressZLib.cxx
DataFile.cxx
DataFileContentCopyMoveParameters.cxx
DataFileContentInformation.cxx
DataFileException.cxx
DataFileTypeEnum.cxx
DescriptiveStatistics.cxx
DeveloperFlagsEnum.cxx
DisplayGroupAndTabItemInterface.cxx
DisplayGroupEnum.cxx
DisplayHighDpiModeEnum.cxx
ElapsedTimer.cxx
Event.cxx
EventAlertUser.cxx
EventBrowserTabClose.cxx
EventBrowserTabDelete.cxx
EventBrowserTabIndicesGetAll.cxx
EventBrowserTabIndicesGetAllViewed.cxx
EventBrowserTabNew.cxx
EventBrowserTabNewClone.cxx
EventBrowserTabReopenClosed.cxx
EventBrowserTabSelectInWindow.cxx
EventBrowserWindowPixelSizeInfoEvent.cxx
EventCaretPreferencesGet.cxx
EventGetViewportSize.cxx
EventListenerInterface.cxx
EventManager.cxx
EventPaletteGetByName.cxx
EventProgressUpdate.cxx
EventRecentFilesSystemAccessMode.cxx
EventResetView.cxx
EventTileTabsGridConfigurationModification.cxx
EventTypeEnum.cxx
FastStatistics.cxx
FileAdapter.cxx
FileInformation.cxx
FileOpenFromOpSysTypeEnum.cxx
FloatMatrix.cxx
HemisphereEnum.cxx
Histogram.cxx
HtmlStringBuilder.cxx
HtmlTableBuilder.cxx
IdentificationDisplayModeEnum.cxx
ImageCaptureMethodEnum.cxx
InfoItem.cxx
JsonHelper.cxx
LinearEquationTransform.cxx
Logger.cxx
LogHandler.cxx
LogHandlerStandardError.cxx
LogLevelEnum.cxx
LogManager.cxx
LogRecord.cxx
MathFunctionEnum.cxx
MathFunctions.cxx
ModelTransform.cxx
NetworkException.cxx
NumericFormatModeEnum.cxx
NumericTextFormatting.cxx
OpenGLDrawingMethodEnum.cxx
PlainTextStringBuilder.cxx
Plane.cxx
ProgramParameters.cxx
ProgramParametersException.cxx
ProgressObject.cxx
QtPluginsPathSetup.cxx
RecentFileItem.cxx
RecentFileItemSortingKeyEnum.cxx
RecentFileItemTypeEnum.cxx
RecentFileItemsContainer.cxx
RecentFileItemsContainerModeEnum.cxx
RecentFileItemsFilter.cxx
RecentFilesSystemAccessModeEnum.cxx
RecentSceneInfoContainer.cxx
ReductionEnum.cxx
ReductionOperation.cxx
SpacerTabIndex.cxx
SpecFileDialogViewFilesTypeEnum.cxx
SpeciesEnum.cxx
StereotaxicSpaceEnum.cxx
StringTableModel.cxx
StructureEnum.cxx
SystemUtilities.cxx
TileTabsBrowserTabGeometry.cxx
TileTabsLayoutBackgroundTypeEnum.cxx
TileTabsLayoutBaseConfiguration.cxx
TileTabsLayoutConfigurationTypeEnum.cxx
TileTabsLayoutGridConfiguration.cxx
TileTabsLayoutManualConfiguration.cxx
TileTabsGridRowColumnContentTypeEnum.cxx
TileTabsGridRowColumnElement.cxx
TileTabsGridRowColumnStretchTypeEnum.cxx
ToolBarWidthModeEnum.cxx
TriStateSelectionStatusEnum.cxx
UnitsConversion.cxx
Vector3D.cxx
VectorOperation.cxx
VolumeMontageCoordinateDisplayTypeEnum.cxx
VolumeSliceViewAllPlanesLayoutEnum.cxx
VoxelColorUpdate.cxx
WorkbenchInstallationAssistant.cxx
WorkbenchQtMessageHandler.cxx
WorkbenchSpecialVersionEnum.cxx
WuQMacro.cxx
WuQMacroCommand.cxx
WuQMacroCommandTypeEnum.cxx
WuQMacroCommandParameter.cxx
WuQMacroDataValueTypeEnum.cxx
WuQMacroFile.cxx
WuQMacroGroup.cxx
WuQMacroGroupXmlStreamBase.cxx
WuQMacroGroupXmlStreamReader.cxx
WuQMacroGroupXmlStreamWriter.cxx
WuQMacroModeEnum.cxx
WuQMacroMouseEventInfo.cxx
WuQMacroMouseEventTypeEnum.cxx
WuQMacroShortCutKeyEnum.cxx
WuQMacroStandardItemTypeEnum.cxx
WuQMacroWidgetTypeEnum.cxx
YokingGroupEnum.cxx
)

ADD_DEFINITIONS(-DCOMPILER_NAME="${CMAKE_CXX_COMPILER}")
ADD_DEFINITIONS(-DCOMPILER_VERSION="${CMAKE_CXX_COMPILER_VERSION}")

#
# Include directories
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Common
)

SET (GIT_REPOSITORY "${CMAKE_SOURCE_DIR}/../.git")
IF (EXISTS ${GIT_REPOSITORY})
    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
        COMMAND ${CMAKE_COMMAND}
            -DINFILE="${CMAKE_SOURCE_DIR}/Common/ApplicationInformation.cxx.in"
            -DOUTFILE="${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx"
            -DVERSION="${WB_VERSION}"
            -P "${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in"
        WORKING_DIRECTORY ${GIT_REPOSITORY}/..
        DEPENDS ApplicationInformation.cxx.in ${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in ${CMAKE_SOURCE_DIR}/CMakeLists.txt ${GIT_REPOSITORY}/HEAD ${GIT_REPOSITORY}/index
        COMMENT "Setting commit info"
    )
ELSE(EXISTS ${GIT_REPOSITORY})
    ADD_CUSTOM_COMMAND(
        OUTPUT ${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx
        COMMAND ${CMAKE_COMMAND}
            -DINFILE="${CMAKE_SOURCE_DIR}/Common/ApplicationInformation.cxx.in"
            -DOUTFILE="${CMAKE_BINARY_DIR}/Common/ApplicationInformation.cxx"
            -DVERSION="${WB_VERSION}"
            -P "${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/..
        DEPENDS ApplicationInformation.cxx.in ${CMAKE_SOURCE_DIR}/CMakeScripts/git_commit_info.cmake.in ${CMAKE_SOURCE_DIR}/CMakeLists.txt
        COMMENT "No repository found, setting commit info to 'unknown'.  Reconfigure to look for the repository again."
    )
ENDIF(EXISTS ${GIT_REPOSITORY})

#
# Conditionally link the dot library to use the SIMD-based dot product implementation
#
IF (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)
    TARGET_LINK_LIBRARIES(Common dot ${CARET_QT5_LINK})
ELSE (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)
    TARGET_LINK_LIBRARIES(Common ${CARET_QT5_LINK})
ENDIF (WORKBENCH_USE_SIMD AND CPUINFO_COMPILES)

=== src/Desktop/CMakeLists.txt ===
#
# Name of Project
#
PROJECT(Desktop)

#
# Name of executable
#
set (EXE_NAME wb_view)

#
# QT Include directories
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    include_directories(${Qt6Network_INCLUDE_DIRS})
#    if(Qt5OpenGL_FOUND)
#        include_directories(${Qt5OpenGL_INCLUDE_DIRS})
#    endif()
    include_directories(${Qt6OpenGLWidgets_INCLUDE_DIRS})
    include_directories(${Qt6Widgets_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
    if(Qt5OpenGL_FOUND)
        include_directories(${Qt5OpenGL_INCLUDE_DIRS})
    endif()
    include_directories(${Qt5Widgets_INCLUDE_DIRS})
endif()

#
# Added by JWH to eliminate OpenGL linking errors in Ubuntu Linux
#
IF (UNIX)
    IF (NOT APPLE)
        FIND_PACKAGE(OpenGL)
    ENDIF (NOT APPLE)
ENDIF (UNIX)

#
# Resources
# Help can be excluded
#
SET (RESOURCES_QRC_FILE
     ../Resources/Data/data_resources.qrc
     ../Resources/General/general_resources.qrc
     ../Resources/Gui/gui_resources.qrc)
IF (WORKBENCH_INCLUDE_HELP_HTML_RESOURCES)
    LIST (APPEND RESOURCES_QRC_FILE
          ../Resources/Help/help_resources.qrc)
ENDIF (WORKBENCH_INCLUDE_HELP_HTML_RESOURCES)

IF (Qt6_FOUND)
    QT6_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ENDIF (Qt6_FOUND)
IF (Qt5_FOUND)
    QT5_ADD_RESOURCES(IMAGE_RCS_SRCS ${RESOURCES_QRC_FILE})
ENDIF (Qt5_FOUND)

#
# Create the executable
# Apple creates a bundle
#
IF (APPLE)
   ADD_EXECUTABLE(${EXE_NAME}
      MACOSX_BUNDLE
      desktop.cxx
      ${IMAGE_RCS_SRCS}
   )

    #
    # This is a customized Info.Plist for Mac so that a spec
    # file can be opened using Finder
    #
    SET_TARGET_PROPERTIES(
	${EXE_NAME}
	PROPERTIES
	MACOSX_BUNDLE_INFO_PLIST 
	${CMAKE_SOURCE_DIR}/../mac_plist/MacOSXBundleInfo.plist.in
    )
	
#   SET_TARGET_PROPERTIES(
#       ${EXE_NAME}
#       PROPERTIES
#       RESOURCE
#       ${QT_BINARY_DIR}/../src/gui/mac/qt_menu.nib
#   )
ENDIF (APPLE)

IF (WIN32)
   ADD_EXECUTABLE(${EXE_NAME}
      desktop.cxx
      ${IMAGE_RCS_SRCS}
      ${CMAKE_SOURCE_DIR}/../icons/windows/workbench.rc
   )
ENDIF (WIN32)
IF (NOT APPLE)
    IF (UNIX)
       ADD_EXECUTABLE(${EXE_NAME}
          desktop.cxx
          ${IMAGE_RCS_SRCS}
       )
    ENDIF (UNIX)
ENDIF (NOT APPLE)

if(Qt5OpenGL_FOUND)
    set(QT5_OPENGL_LIB_NAME Qt5::OpenGL)
endif()
if(Qt6_FOUND)
    set(QT6_LINK_LIBS
        Qt6::Concurrent
        Qt6::Core
        Qt6::Core5Compat
        Qt6::Gui
        Qt6::Network
        Qt6::OpenGLWidgets
        Qt6::PrintSupport
        Qt6::Test
        Qt6::Widgets
        Qt6::Xml)
endif()
if(Qt5_FOUND)
    set(QT5_LINK_LIBS
        Qt5::Concurrent
        Qt5::Core
        Qt5::Gui
        Qt5::Network
        ${QT5_OPENGL_LIB_NAME}
        Qt5::PrintSupport
        Qt5::Test
	${WB_WEBKIT_LIBS}
        Qt5::Widgets
        Qt5::Xml)
endif()

#
# Libraries that are linked
#
TARGET_LINK_LIBRARIES(${EXE_NAME}
GuiQt
Commands
Operations
Algorithms
OperationsBase
${Qwt_LIBRARIES}
OSMesaDummy
Brain
Files
${FTGL_LIBRARIES}
Annotations
Graphics
Charting
Palette
Cifti
Gifti
Nifti
QxtCore
FilesBase
Scenes
Xml
CZICmd
CZI
CZIJxrDecode
${OME_ZARR_LIBRARY_FOR_LINKING}
Common
${GLEW_LIBRARIES}
${QUAZIP_LIBRARIES}
${FREETYPE_LIBRARIES}
${QT_LIBRARIES}
${QT6_LINK_LIBS}
${QT5_LINK_LIBS}
${Z5_COMPRESSION_LIBRARIES}
${ZLIB_LIBRARIES}
${OPENMP_LIBRARY}
#${LIBS}
)

INCLUDE(GNUInstallDirs)

INSTALL(TARGETS ${EXE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})

IF(WIN32)
    TARGET_LINK_LIBRARIES(${EXE_NAME}
    opengl32
    glu32
    )
ENDIF(WIN32)

IF (UNIX)
   IF (NOT APPLE) 
      TARGET_LINK_LIBRARIES(${EXE_NAME}
         ${OPENGL_LIBRARIES}
         gobject-2.0
      )
   ENDIF (NOT APPLE)

#   EXECUTE_PROCESS(COMMAND uname -n OUTPUT_VARIABLE MACHINE_NAME)
#   MESSAGE("MACHINE_NAME: ${MACHINE_NAME}")
#   IF (${MACHINE_NAME} MATCHES "linuxbuild")
#       MESSAGE("is linuxbuild")
#       SET_TARGET_PROPERTIES(${EXE_NAME}
#                          PROPERTIES
#                          LINK_FLAGS "-Wl,-E"
#                          LINK_FLAGS_DEBUG "-Wl,-E"
#                          LINK_FLAGS_RELEASE "-Wl,-E")
#   ENDIF()
ENDIF (UNIX)

#
# At this time, Cocoa needs to be explicitly added for Apple Mac
#
IF (APPLE)
   #SET (QT_MAC_USE_COCOA TRUE)
   TARGET_LINK_LIBRARIES(${EXE_NAME}
     "-framework Cocoa"
     "-framework OpenGL"
   )
ENDIF (APPLE)

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Desktop
${CMAKE_SOURCE_DIR}/Algorithms
${CMAKE_SOURCE_DIR}/Commands
${CMAKE_SOURCE_DIR}/GuiQt
${CMAKE_SOURCE_DIR}/Brain
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/OmeZarr
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Nifti
${Qwt_INCLUDE_DIRS}
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

#
# Apple needs qt_menu.nib directory copied
# into application's Resources directory 
#
# Apple needs framework
#
IF (APPLE)
        ADD_CUSTOM_COMMAND(
            TARGET ${EXE_NAME}
            POST_BUILD
            COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_nib.sh ${EXE_NAME}
            ###COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_frameworks.sh ${EXE_NAME}
        )
ENDIF (APPLE)

IF (APPLE)
    SET (MACOSX_BUNDLE_INFO_STRING wb_view Copyright 2024 )
    SET (MACOSX_BUNDLE_ICON_FILE workbench.icns )
    ##SET (MACOSX_BUNDLE_GUI_IDENTIFIER wb_view )
    ## Underscore is not valid in MACOSX_BUNDLE_GUI_IDENTIFIER
    SET (MACOSX_BUNDLE_GUI_IDENTIFIER workbench )
    SET (MACOSX_BUNDLE_LONG_VERSION_STRING wb_view)
    SET (MACOSX_BUNDLE_BUNDLE_NAME wb_view)
    SET (MACOSX_BUNDLE_SHORT_VERSION_STRING ${WB_VERSION})
    SET (MACOSX_BUNDLE_BUNDLE_VERSION ${WB_VERSION})
    SET (MACOSX_BUNDLE_COPYRIGHT  2024 )

    ADD_CUSTOM_COMMAND(
        TARGET ${EXE_NAME}
        POST_BUILD
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/wb_view.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/workbench.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/spec_file.icns
        COMMAND ${CMAKE_SOURCE_DIR}/CMakeScripts/copy_mac_icon.sh ${EXE_NAME} ${CMAKE_SOURCE_DIR}/../icons/mac/data_file.icns
    )
ENDIF (APPLE)

=== src/Files/CMakeLists.txt ===
#
# Name of project
#
PROJECT (Files)

#
# Add QT for includes
#
if(Qt6_FOUND)
    include_directories(${Qt6Core_INCLUDE_DIRS})
    include_directories(${Qt6Gui_INCLUDE_DIRS})
    include_directories(${Qt6Network_INCLUDE_DIRS})
endif()
if(Qt5_FOUND)
    include_directories(${Qt5Core_INCLUDE_DIRS})
    include_directories(${Qt5Gui_INCLUDE_DIRS})
    include_directories(${Qt5Network_INCLUDE_DIRS})
endif()

#
# With AUTOMOC, do not need to specify files
# that contain Q_OBJECT macro for Qt to process with 'moc'
# (meta-object compiler).
#
IF(WORKBENCH_USE_CMAKE_AUTOMOC)
    SET(CMAKE_AUTOMOC ON)
ELSE()
    SET(MOC_INPUT_HEADER_FILES
        DataFileEditorModel.h
        LabelSelectionItemModel.h
    )

    IF(Qt6_FOUND)
        QT6_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF()
    IF(Qt5_FOUND)
        QT5_WRAP_CPP(MOC_SOURCE_FILES ${MOC_INPUT_HEADER_FILES})
    ENDIF()
ENDIF()

#
# Files Library
#
ADD_LIBRARY(Files
AffineFile.h
AffineSeriesFile.h
AnnotationFile.h
AnnotationFileXmlFormatBase.h
AnnotationFileXmlReader.h
AnnotationFileXmlWriter.h
AnnotationTextSubstitutionFile.h
Border.h
BorderException.h
BorderFile.h
BorderLengthHelper.h
BorderPointFromSearch.h
BorderTracingHelper.h
BrainordinateRegionOfInterest.h
CaretDataFile.h
CaretDataFileHelper.h
CaretDataFileSelectionModel.h
CaretMappableDataFile.h
CaretMappableDataFileAndMapSelectionModel.h
CaretMappableDataFileClusterFinder.h
CaretMappableDataFileLabelSelectionDelegate.h
CaretSparseFile.h
CaretVolumeExtension.h
ChartableLineSeriesBrainordinateInterface.h
ChartableLineSeriesInterface.h
ChartableLineSeriesRowColumnInterface.h
ChartableMatrixInterface.h
ChartableMatrixParcelInterface.h
ChartableMatrixSeriesInterface.h
ChartableTwoFileDelegate.h
ChartableTwoFileBaseChart.h
ChartableTwoFileHistogramChart.h
ChartableTwoFileLineLayerChart.h
ChartableTwoFileLineSeriesChart.h
ChartableTwoFileMatrixChart.h
CiftiBrainordinateDataSeriesFile.h
CiftiBrainordinateLabelFile.h
CiftiBrainordinateScalarFile.h
CiftiConnectivityMatrixDenseFile.h
CiftiConnectivityMatrixDenseDynamicFile.h
CiftiConnectivityMatrixDenseParcelFile.h
CiftiConnectivityMatrixParcelDynamicFile.h
CiftiConnectivityMatrixParcelFile.h
CiftiConnectivityMatrixParcelDenseFile.h
CiftiFiberOrientationFile.h
CiftiFiberTrajectoryFile.h
CiftiFiberTrajectoryMapFile.h
CiftiMappableDataFile.h
CiftiMappableConnectivityMatrixDataFile.h
CiftiParcelColoringModeEnum.h
CiftiParcelLabelFile.h
CiftiParcelReordering.h
CiftiParcelReorderingModel.h
CiftiParcelSeriesFile.h
CiftiParcelScalarFile.h
CiftiScalarDataSeriesFile.h
CommaSeparatedValuesFile.h
ConnectivityCorrelationTwo.h
ConnectivityCorrelationModeEnum.h
ConnectivityCorrelationSettings.h
ConnectivityDataLoaded.h
ControlPointFile.h
CziDistanceFile.h
CziImage.h
CziImageFile.h
CziImageLoaderBase.h
CziImageLoaderMultiResolution.h
CziImageResolutionChangeModeEnum.h
CziNonLinearTransform.h
CziPixelCoordSpaceEnum.h
CziUtilities.h
DataFileColorModulateSelector.h
DataFileEditorColumnContent.h
DataFileEditorItem.h
DataFileEditorItemTypeEnum.h
DataFileEditorModel.h
DingOntologyTermsFile.h
EventCaretDataFilesGet.h
EventCaretMappableDataFileMapsViewedInOverlays.h
EventCaretMappableDataFilesGet.h
EventChartMatrixParcelYokingValidation.h
EventFocusFileGetColor.h
EventGetDisplayedDataFiles.h
EventHistologySlicesFilesGet.h
EventMapYokingSelectMap.h
EventMapYokingValidation.h
EventMediaFilesGet.h
EventSurfaceColoringInvalidate.h
EventSurfaceFileGet.h
EventSurfaceStructuresValidGet.h
EventVolumeColoringInvalidate.h
Fiber.h
FiberOrientation.h
FiberOrientationColoringTypeEnum.h
FiberOrientationTrajectory.h
FiberTrajectoryColorModel.h
FiberTrajectoryMapProperties.h
FiberTrajectoryDisplayModeEnum.h
FileIdentificationAttributes.h
FileIdentificationDisplayModeEnum.h
FileIdentificationMapSelectionEnum.h
FilePathNamePrefixCompactor.h
FociFile.h
FociFileSaxReader.h
Focus.h
GeodesicHelper.h
GiftiTypeFile.h
GroupAndNameCheckStateEnum.h
GroupAndNameHierarchyGroup.h
GroupAndNameHierarchyItem.h
GroupAndNameHierarchyModel.h
GroupAndNameHierarchyName.h
GroupAndNameHierarchyUserInterface.h
HistologyCoordinate.h
HistologySlice.h
HistologySliceImage.h
HistologySlicesFile.h
HistologySlicesFileXmlStreamBase.h
HistologySlicesFileXmlStreamReader.h
ImageCaptureDimensionsModeEnum.h
ImageCaptureDialogSettings.h
ImageFile.h
ImageResolutionUnitsEnum.h
ImageSpatialUnitsEnum.h
LabelDrawingProperties.h
LabelDrawingTypeEnum.h
LabelFile.h
LabelSelectionItem.h
LabelSelectionItemModel.h
MapYokingGroupEnum.h
MediaDisplayCoordinateModeEnum.h
MediaFile.h
MediaFileChannelInfo.h
MediaFileTransforms.h
MetricDynamicConnectivityFile.h
MetricFile.h
MetricSmoothingObject.h
NodeAndVoxelColoring.h
OmeZarrImageFile.h
OxfordSparseThreeFile.h
PaletteFile.h
PixelCoordinate.h
PixelIndex.h
PixelLogicalIndex.h
RectangleTransform.h
RgbaFile.h
RibbonMappingHelper.h
SamplesColorModeEnum.h
SamplesFile.h
SceneDataFileInfo.h
SceneFile.h
SceneFileXmlStreamBase.h
SceneFileXmlStreamReader.h
SceneFileXmlStreamWriter.h
SignedDistanceHelper.h
SparseVolumeIndexer.h
SpecFile.h
SpecFileDataFileTypeGroup.h
SpecFileDataFile.h
SpecFileSaxReader.h
StudyMetaDataLink.h
StudyMetaDataLinkSet.h
StudyMetaDataLinkSetSaxReader.h
SurfaceFile.h
SurfacePlaneIntersectionToContour.h
SurfaceProjectedItem.h
SurfaceProjectedItemSaxReader.h
SurfaceProjection.h
SurfaceProjectionBarycentric.h
SurfaceProjectionVanEssen.h
SurfaceProjector.h
SurfaceProjectorException.h
SurfaceResamplingHelper.h
SurfaceResamplingMethodEnum.h
SurfaceTypeEnum.h
TextFile.h
TopologyHelper.h
VolumeDynamicConnectivityFile.h
VolumeEditingModeEnum.h
VolumeFile.h
VolumeFileEditorDelegate.h
VolumeFileVoxelColorizer.h
VolumeGraphicsPrimitiveManager.h
VolumeMapUndoCommand.h
VolumePaddingHelper.h
VolumePlaneIntersection.h
VolumeSliceProjectionTypeEnum.h
VolumeSpline.h
VolumeToImageMapping.h
VolumeVerticesEdgesFaces.h
VoxelInterpolationTypeEnum.h
VtkFileExporter.h
WarpfieldFile.h
XmlStreamReaderHelper.h
XmlStreamWriterHelper.h

${MOC_SOURCE_FILES}

AffineFile.cxx
AffineSeriesFile.cxx
AnnotationFile.cxx
AnnotationFileXmlFormatBase.cxx
AnnotationFileXmlReader.cxx
AnnotationFileXmlWriter.cxx
AnnotationTextSubstitutionFile.cxx
Border.cxx
BorderException.cxx
BorderFile.cxx
BorderLengthHelper.cxx
BorderTracingHelper.cxx
BrainordinateRegionOfInterest.cxx
CaretDataFile.cxx
CaretDataFileHelper.cxx
CaretDataFileSelectionModel.cxx
CaretMappableDataFile.cxx
CaretMappableDataFileAndMapSelectionModel.cxx
CaretMappableDataFileClusterFinder.cxx
CaretMappableDataFileLabelSelectionDelegate.cxx
CaretSparseFile.cxx
CaretVolumeExtension.cxx
ChartableLineSeriesInterface.cxx
ChartableMatrixInterface.cxx
ChartableTwoFileDelegate.cxx
ChartableTwoFileBaseChart.cxx
ChartableTwoFileHistogramChart.cxx
ChartableTwoFileLineLayerChart.cxx
ChartableTwoFileLineSeriesChart.cxx
ChartableTwoFileMatrixChart.cxx
CiftiBrainordinateDataSeriesFile.cxx
CiftiBrainordinateLabelFile.cxx
CiftiBrainordinateScalarFile.cxx
CiftiConnectivityMatrixDenseFile.cxx
CiftiConnectivityMatrixDenseDynamicFile.cxx
CiftiConnectivityMatrixDenseParcelFile.cxx
CiftiConnectivityMatrixParcelFile.cxx
CiftiConnectivityMatrixParcelDynamicFile.cxx
CiftiConnectivityMatrixParcelDenseFile.cxx
CiftiFiberOrientationFile.cxx
CiftiFiberTrajectoryFile.cxx
CiftiFiberTrajectoryMapFile.cxx
CiftiMappableDataFile.cxx
CiftiMappableConnectivityMatrixDataFile.cxx
CiftiParcelColoringModeEnum.cxx
CiftiParcelLabelFile.cxx
CiftiParcelReordering.cxx
CiftiParcelReorderingModel.cxx
CiftiParcelSeriesFile.cxx
CiftiParcelScalarFile.cxx
CiftiScalarDataSeriesFile.cxx
CommaSeparatedValuesFile.cxx
ConnectivityCorrelationTwo.cxx
ConnectivityCorrelationModeEnum.cxx
ConnectivityCorrelationSettings.cxx
ConnectivityDataLoaded.cxx
ControlPointFile.cxx
CziDistanceFile.cxx
CziImage.cxx
CziImageFile.cxx
CziImageLoaderBase.cxx
CziImageLoaderMultiResolution.cxx
CziImageResolutionChangeModeEnum.cxx
CziNonLinearTransform.cxx
CziPixelCoordSpaceEnum.cxx
CziUtilities.cxx
DataFileColorModulateSelector.cxx
DataFileEditorColumnContent.cxx
DataFileEditorItem.cxx
DataFileEditorItemTypeEnum.cxx
DataFileEditorModel.cxx
DingOntologyTermsFile.cxx
EventCaretDataFilesGet.cxx
EventCaretMappableDataFileMapsViewedInOverlays.cxx
EventCaretMappableDataFilesGet.cxx
EventChartMatrixParcelYokingValidation.cxx
EventFocusFileGetColor.cxx
EventGetDisplayedDataFiles.cxx
EventHistologySlicesFilesGet.cxx
EventMapYokingSelectMap.cxx
EventMapYokingValidation.cxx
EventMediaFilesGet.cxx
EventSurfaceColoringInvalidate.cxx
EventSurfaceFileGet.cxx
EventSurfaceStructuresValidGet.cxx
EventVolumeColoringInvalidate.cxx
Fiber.cxx
FiberOrientation.cxx
FiberOrientationColoringTypeEnum.cxx
FiberOrientationTrajectory.cxx
FiberTrajectoryColorModel.cxx
FiberTrajectoryDisplayModeEnum.cxx
FiberTrajectoryMapProperties.cxx
FileIdentificationAttributes.cxx
FileIdentificationDisplayModeEnum.cxx
FileIdentificationMapSelectionEnum.cxx
FilePathNamePrefixCompactor.cxx
FociFile.cxx
FociFileSaxReader.cxx
Focus.cxx
GeodesicHelper.cxx
GiftiTypeFile.cxx
GroupAndNameCheckStateEnum.cxx
GroupAndNameHierarchyGroup.cxx
GroupAndNameHierarchyItem.cxx
GroupAndNameHierarchyModel.cxx
GroupAndNameHierarchyName.cxx
HistologyCoordinate.cxx
HistologySlice.cxx
HistologySliceImage.cxx
HistologySlicesFile.cxx
HistologySlicesFileXmlStreamBase.cxx
HistologySlicesFileXmlStreamReader.cxx
ImageCaptureDimensionsModeEnum.cxx
ImageCaptureDialogSettings.cxx
ImageFile.cxx
ImageResolutionUnitsEnum.cxx
ImageSpatialUnitsEnum.cxx
LabelDrawingProperties.cxx
LabelDrawingTypeEnum.cxx
LabelFile.cxx
LabelSelectionItem.cxx
LabelSelectionItemModel.cxx
MapYokingGroupEnum.cxx
MediaDisplayCoordinateModeEnum.cxx
MediaFile.cxx
MediaFileChannelInfo.cxx
MediaFileTransforms.cxx
MetricDynamicConnectivityFile.cxx
MetricFile.cxx
MetricSmoothingObject.cxx
NodeAndVoxelColoring.cxx
OmeZarrImageFile.cxx
OxfordSparseThreeFile.cxx
PaletteFile.cxx
PixelCoordinate.cxx
PixelIndex.cxx
PixelLogicalIndex.cxx
RectangleTransform.cxx
RgbaFile.cxx
RibbonMappingHelper.cxx
SamplesColorModeEnum.cxx
SamplesFile.cxx
SceneDataFileInfo.cxx
SceneFile.cxx
SceneFileXmlStreamBase.cxx
SceneFileXmlStreamReader.cxx
SceneFileXmlStreamWriter.cxx
SignedDistanceHelper.cxx
SparseVolumeIndexer.cxx
SpecFile.cxx
SpecFileDataFileTypeGroup.cxx
SpecFileDataFile.cxx
SpecFileSaxReader.cxx
StudyMetaDataLink.cxx
StudyMetaDataLinkSet.cxx
StudyMetaDataLinkSetSaxReader.cxx
SurfaceFile.cxx
SurfacePlaneIntersectionToContour.cxx
SurfaceProjectedItem.cxx
SurfaceProjectedItemSaxReader.cxx
SurfaceProjection.cxx
SurfaceProjectionBarycentric.cxx
SurfaceProjectionVanEssen.cxx
SurfaceProjector.cxx
SurfaceProjectorException.cxx
SurfaceResamplingHelper.cxx
SurfaceResamplingMethodEnum.cxx
SurfaceTypeEnum.cxx
TextFile.cxx
TopologyHelper.cxx
VolumeDynamicConnectivityFile.cxx
VolumeEditingModeEnum.cxx
VolumeFile.cxx
VolumeFileEditorDelegate.cxx
VolumeFileVoxelColorizer.cxx
VolumeGraphicsPrimitiveManager.cxx
VolumeMapUndoCommand.cxx
VolumePaddingHelper.cxx
VolumePlaneIntersection.cxx
VolumeSliceProjectionTypeEnum.cxx
VolumeSpline.cxx
VolumeToImageMapping.cxx
VolumeVerticesEdgesFaces.cxx
VoxelInterpolationTypeEnum.cxx
VtkFileExporter.cxx
WarpfieldFile.cxx
XmlStreamReaderHelper.cxx
XmlStreamWriterHelper.cxx
)

TARGET_LINK_LIBRARIES(Files ${CARET_QT5_LINK})

#
# Find Headers
#
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/Annotations
${CMAKE_SOURCE_DIR}/Charting
${CMAKE_SOURCE_DIR}/CZIlib/CZI
${CMAKE_SOURCE_DIR}/Files
${CMAKE_SOURCE_DIR}/FilesBase
${CMAKE_SOURCE_DIR}/Graphics
${CMAKE_SOURCE_DIR}/Cifti
${CMAKE_SOURCE_DIR}/Palette
${CMAKE_SOURCE_DIR}/Gifti
${CMAKE_SOURCE_DIR}/Nifti
${CMAKE_SOURCE_DIR}/QxtCore
${CMAKE_SOURCE_DIR}/Scenes
${CMAKE_SOURCE_DIR}/Xml
${CMAKE_SOURCE_DIR}/Common
)

IF (${HAVE_OME_ZARR_Z5_FLAG})
    INCLUDE_DIRECTORIES(
        ${CMAKE_SOURCE_DIR}/OmeZarr
    )
ENDIF ()

=== debian/changelog ===
connectome-workbench (2.1.0-1) experimental; urgency=medium

  * Fresh upstream release, upload to experimental due to upcoming trixie
    release.
    - removing debian/patches/7ba3345d161d567a4b628ceb02ab4471fc96cb20.patch
    - added debian/patches/0001-attempted-*.patch to address FTBFS for Qt5

 -- Yaroslav Halchenko <debian@onerussian.com>  Wed, 30 Jul 2025 08:47:04 -0400

=== debian/control ===
Source: connectome-workbench
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               help2man,
               cmake,
               libosmesa6-dev,
               qtbase5-dev,
               libssl-dev,
               zlib1g-dev,
               libqt5opengl5-dev,
               libglib2.0-dev,
               libglm-dev (>= 0.9.9.6~),
               opencl-c-headers,
               xauth,
               xvfb,
               libftgl-dev
Standards-Version: 4.4.1
Vcs-Browser: http://github.com/neurodebian/workbench
Vcs-Git: https://github.com/neurodebian/workbench -b debian
Homepage: http://www.nitrc.org/projects/workbench/

Package: connectome-workbench
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: caret
Suggests: ffmpeg
Description: brain visualization, analysis and discovery tool
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.

Package: connectome-workbench-dbg
Architecture: any
Section: debug
Depends: ${shlibs:Depends},
         ${misc:Depends},
         connectome-workbench (= ${binary:Version})
Description: brain visualization, analysis and discovery tool -- debug symbols
 Connectome Workbench is a brain visualization, analysis and discovery
 tool for fMRI and dMRI brain imaging data, including functional and
 structural connectivity data generated by the Human Connectome
 Project.
 .
 Package includes wb_command, a command-line program for performing a
 variety of analytical tasks for volume, surface, and CIFTI
 grayordinates data.
 .
 This package contains debug symbols for the binaries.

=== debian/watch ===
version=4
opts="uversionmangle=s/v//,filenamemangle=s/.*\/(.*)/connectome-workbench-$1/" \
  https://github.com/Washington-University/workbench/tags .*/v?(\d.*)@ARCHIVE_EXT@
# http://github.com/Washington-University/workbench/releases .*archive/v?([\d\.rc]+).tar.gz
